<?
// ---------------------------------------------------------
// DView 2.1 - 2013-09-01
// www.dview.de
//  2013 Ingmar Ober - www.oberin.de
// Released under the Creative Commons License CC-BY-SA.
// http://creativecommons.org/licenses/by-sa/3.0/deed.de
// ---------------------------------------------------------
session_start();
include ("../../config/ini.main.php");
header("Content-Type: text/javascript; charset=iso-8859-1");
?>
document.onmousemove = function(arg){
	this.Mx = (arg?arg.pageX:event.clientX+document.body.scrollLeft);
	this.My = (arg?arg.pageY:event.clientY+document.body.scrollTop);
}
var DateType = function(strDate){
	if(!(this instanceof DateType)) return new DateType(strDate);
	this.arConfig = {
		"DayAtNull" : 5
	};
	this.arDaysAtMonth = new Array(0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
	this.NormalizeDate = function(){
		if(this.intYear < 1) this.intYear = 1;
		if(this.intMonth > 12){
			this.intYear += Math.floor(this.intMonth / 12);
			this.intMonth = this.intMonth % 12;
		}
		if(this.intMonth < 1){
			this.intYear += Math.ceil((this.intMonth - 1) / 12) - 1;
			this.intMonth = 12 + (this.intMonth % 12);
		}
		while(this.intDay > this.GetLastDayOfMonth()){
			this.intDay -= this.GetLastDayOfMonth();
			this.intMonth++;
			if(this.intMonth > 12){
				this.intYear += Math.floor(this.intMonth / 12);
				this.intMonth = this.intMonth % 12;
			}
		}
		while(this.intDay < 1){
			this.intDay += this.GetLastDayOfMonthBefore();
			this.intMonth--;
			if(this.intMonth < 1){
				this.intYear += Math.ceil((this.intMonth - 1) / 12) - 1;
				this.intMonth = 12 + (this.intMonth % 12);
			}
		}
		if(this.IsMissingDate()){
			this.intDay = 4;
		}
		this.RecalcParams();
	}
	this.GetTotalDays = function(){
		var intTDays = (this.intYear - 1) * 365 + this.intDay - 1;
		for(var i = 1; i < this.intMonth; i++) intTDays += this.arDaysAtMonth[i];
		if(this.intYear > 1582 || (this.intYear == 1582 && this.intMonth > 10) || (this.intYear == 1582 && this.intMonth == 10 && this.intDay > 4)){
			if(this.IsMissingDate()){
				return 577736;
			}
			else{
				intTDays -= 10;
			}
		}
		var intLeapYears = Math.floor(this.intYear / 4);
		intLeapYears -= (this.intYear % 4 == 0 && this.intMonth < 3 ? 1 : 0);
		if(this.intYear > 1600){
			intLeapYears -= Math.floor((this.intYear - 1600) / 100);
			intLeapYears += Math.floor((this.intYear - 1600) / 400);
			intLeapYears -= (this.intYear % 100 == 0 && this.intYear % 400 != 0 && this.intMonth < 3 ? 1 : 0);
		}
		return intTDays + intLeapYears;
	}
	this.IsMissingDate = function(){
		return (this.intYear == 1582 && this.intMonth == 10 && this.intDay > 4 && this.intDay < 15);
	}
	this.IsLeapYear = function(){
		return (this.intYear % 400 == 0 ? 1 : (this.intYear % 100 == 0 ? 0 : (this.intYear % 4 == 0 ? 1 : 0)));
	}
	this.GetMonthDays = function(){
		return this.arDaysAtMonth[this.intMonth] + (this.IsLeapYear() == 1 && this.intMonth == 2 ? 1 : 0) - (this.intYear == 1582 && this.intMonth == 10 ? 10 : 0);
	}
	this.GetLastDayOfMonth = function(){
		return this.arDaysAtMonth[this.intMonth] + (this.IsLeapYear() == 1 && this.intMonth == 2 ? 1 : 0);
	}
	this.GetLastDayOfMonthBefore=function(){
		var objDate = new DateType(this.intYear + "-" + this.intMonth + "-01");
		objDate.DecMonth();
		return objDate.GetLastDayOfMonth();
	}
	this.CalcCalendarWeek = function(){
		if(this.intMonth == 1 && this.intDay == 4) return 1;
		var objDate = new DateType(this.intYear + "-01-04");
		if(this.intMonth == 1 && this.intDay < 4){
			var sYearBF = this.intYear - 1;
			var objDateBF = new DateType((this.intYear - 1) + "-12-31");
			if(4 - objDate.intWeekDay >= this.intDay){
				return objDateBF.intCalendarWeek;
			}
			else{
				return 1;
			}
		}
		if(this.intMonth == 12 && this.intDay > 28){
			var objDateAF = new DateType((this.intYear + 1) + "-01-04");
			if(8 - objDateAF.intWeekDay < this.intDay - 27){
				return 1;
			}
		}
		return Math.ceil((this.intYearDay + (objDate.intWeekDay - 3)) / 7);
	}
	this.RecalcParams = function(){
		this.intWeekDay = ((this.GetTotalDays() + this.arConfig["DayAtNull"]) % 7) + 1;
		this.intYearDay = this.intDay;
		for(var i = 1; i < this.intMonth; i++) this.intYearDay += this.arDaysAtMonth[i];
		if(this.intYear == 1582 && (this.intMonth > 10 || (this.intMonth == 10 && this.intDay > 4)))this.intYearDay-=10;
		this.intCalendarWeek = this.CalcCalendarWeek();
	}
	this.IncDay = function(){
		if(this.intYear == 1582 && this.intMonth == 10 && this.intDay == 4){
			this.intDay = 15;
		}
		else{
			this.intDay++;
			this.NormalizeDate();
		}
	}
	this.DecDay = function(){
		if(this.intYear == 1 && this.intMonth == 1 && this.intDay == 1) return;
		if(this.intYear == 1582 && this.intMonth == 10 && this.intDay == 15){
			this.intDay = 4;
		}
		else{
			this.intDay--;
			this.NormalizeDate();
		}
	}
	this.IncMonth = function(){
		var intDay = this.intDay;
		this.intDay = 1;
		this.intMonth++;
		this.NormalizeDate();
		if(intDay > this.GetLastDayOfMonth()){
			this.intDay = this.GetLastDayOfMonth();
		}
		else{
			this.intDay = intDay;
		}
		this.NormalizeDate();
	}
	this.DecMonth = function(){
		if(this.intYear == 1 && this.intMonth == 1) return;
		var intDay = this.intDay;
		this.intDay = 1;
		this.intMonth--;
		this.NormalizeDate();
		if(intDay > this.GetLastDayOfMonth()){
			this.intDay = this.GetLastDayOfMonth();
		}
		else{
			this.intDay = intDay;
		}
		this.NormalizeDate();
	}
	this.IncYear = function(){
		var intDay = this.intDay;
		this.intDay = 1;
		this.intYear++;
		this.NormalizeDate();
		if(intDay > this.GetLastDayOfMonth()){
			this.intDay = this.GetLastDayOfMonth();
		}
		else{
			this.intDay = intDay;
		}
		this.NormalizeDate();
	}
	this.DecYear = function(){
		if(this.intYear == 1) return;
		var intDay = this.intDay;
		this.intDay = 1;
		this.intYear--;
		this.NormalizeDate();
		if(intDay > this.GetLastDayOfMonth()){
			this.intDay = this.GetLastDayOfMonth();
		}
		else{
			this.intDay = intDay;
		}
		this.NormalizeDate();
	}
	this.getMySQL = function(){
		var strYear = "0000" + this.intYear;
		var strMonth = "00" + this.intMonth;
		var strDay = "00" + this.intDay;
		return strYear.substr(strYear.length - 4, 4) + "-" + strMonth.substr(strMonth.length - 2, 2) + "-" + strDay.substr(strDay.length - 2, 2);
	}
	if(strDate != ""){
		var arDate = strDate.split("-");
		this.intYear = parseInt(arDate[0],10);
		this.intMonth = parseInt(arDate[1],10);
		this.intDay = parseInt(arDate[2],10);
		this.NormalizeDate();
	}
	else{
		this.intYear = 1;
		this.intMonth = 1;
		this.intDay = 1;
		this.intWeekDay = 6;
		this.intYearDay = 1;
		this.intCalendarWeek = 52;
	}
}
var CalendarPOP = function(strDate){
	if(!(this instanceof CalendarPOP)) return new CalendarPOP();
	this.objDate = new DateType(strDate);
	this.objBODY = document.getElementsByTagName("body")[0];
	this.objMainDIV = document.createElement("div");
	this.objMainDIV.style.position = "absolute";
	this.objMainDIV.style.display = "none";
	this.objBODY.appendChild(this.objMainDIV);
	this.objCalendar = new Calendar(this.objMainDIV, this);
	this.ShowCalendar = function(objTarget){
		this.objTarget = objTarget;
		this.objMainDIV.style.top = document.My;
		this.objMainDIV.style.left = document.Mx;
		this.objMainDIV.style.display = "inline";
	}
	this.SetDate = function(objDate){
		this.objMainDIV.style.display = "none";
		this.objTarget.value = objDate.getMySQL().substr(8,2)+"."+objDate.getMySQL().substr(5,2)+"."+objDate.getMySQL().substr(0,4);
	}
	this.clear = function(){
		this.objBODY.removeChild(this.objMainDIV);
	}
}

var Calendar = function(objTarget, objParent){
	if(!(this instanceof Calendar)) return new Calendar(objTarget, objParent);
	this.objTarget = objTarget;
	this.objParent = objParent;
	this.objDate = objParent.objDate;
	this.objToday = new DateType("<?=date("Y-m-d", time())?>");
	this.objCNT = new Object();
	this.arConfig = {
		"css" : {
			"mainTBL" : "cal_tbl_main",
			"controlyearmonthTR" : "cal_tr_controlyearmonth",
			"controlyearleftTD" : "cal_td_controlyearleft",
			"controlyaerleftIMG" : "cal_img_controlyearleft",
			"controlmonthleftTD" : "cal_td_controlmonthleft",
			"controlmonthleftIMG" : "cal_img_controlmonthleft",
			"controlyearmonthcenterTD" : "cal_td_controlyearmonthcenter",
			"controlmonthrightTD" : "cal_td_controlmonthright",
			"controlmonthrightIMG" : "cal_img_controlmonthright",
			"controlyearrightTD" : "cal_td_controlyearright",
			"controlyearrightIMG" : "cal_img_controlyearright",
			"controldayTR" : "cal_tr_controlday",
			"controldayleftTD" : "cal_td_controldayleft",
			"controldayleftIMG" : "cal_img_controldayleft",
			"controldaycenterTD" : "cal_td_controldaycenter",
			"controldayrightTD" : "cal_td_controldayright",
			"controldayrightIMG" : "cal_img_controldayright",
			"calendarTR" : "cal_tr_calendar",
			"calendarTD" : "cal_td_calendar",
			"calendarTBL" : "cal_tbl_calendar",
			"weekdayTR" : "cal_tr_weekday",
			"weekdayTD" : "cal_td_weekday",
			"datesTR" : "cal_tr_dates",
			"calweekTD" : "cal_td_calweek",
			"datesTD" : "cal_td_dates",
			"overdatesTD" : "cal_td_overdates",
			"seldatesTD" : "cal_td_seldates",
			"overseldatesTD" : "cal_td_overseldates",
			"nodatesTD" : "cal_td_nodates",
			"overnodatesTD" : "cal_td_overnodates",
			"selnodatesTD" : "cal_td_selnodates",
			"overselnodatesTD" : "cal_td_overselnodates",
			"nodataTD" : "cal_td_nodata"
		},
		"paths" : {
			"path2images" : "img/"
		},
		"month" : ["Januar", "Februar", "Mrz", "April", "Mai", "Juni", "Juli", "August", "September", "Oktober", "November", "Dezember"],
		"weekday" : ["Mo", "Di", "Mi", "Do", "Fr", "Sa", "So"],
		"calweek" : "KW",
		"today" : "Heute"
	};
	var objMainTBL = document.createElement("table");
	objMainTBL.cellPadding = 0;
	objMainTBL.cellSpacing = 0;
	objMainTBL.className = this.arConfig.css.mainTBL;
	objTarget.appendChild(objMainTBL);
	objMainTBL.appendChild(document.createElement("thead"));
	objMainTBL.appendChild(document.createElement("tfoot"));
	var objMainTBO = document.createElement("tbody");
	objMainTBL.appendChild(objMainTBO);
	var objControlYearMonthTR = document.createElement("tr");
	objControlYearMonthTR.className = this.arConfig.css.controlyearmonthTR;
	objMainTBO.appendChild(objControlYearMonthTR);
	var objControlYearLeftTD = document.createElement("td");
	objControlYearLeftTD.className = this.arConfig.css.controlyearleftTD;
	objControlYearLeftTD.objMaster = this;
	objControlYearLeftTD.onclick = function(){
		this.objMaster.objDate.DecYear();
		this.objMaster.objCNT.objControlYearMonthCenterTD.innerHTML = this.objMaster.arConfig.month[this.objMaster.objDate.intMonth - 1] + "&nbsp;" + this.objMaster.objDate.intYear;
		this.objMaster.GetDaysData();
//		this.objMaster.objParent.SetDate(this.objMaster.objDate);
	}
	objControlYearMonthTR.appendChild(objControlYearLeftTD);
	var objControlYearLeftIMG = document.createElement("img");
	objControlYearLeftIMG.className = this.arConfig.css.controlyearleftIMG;
	objControlYearLeftIMG.src = this.arConfig.paths.path2images + "cal_controlyearleft.gif";
	objControlYearLeftTD.appendChild(objControlYearLeftIMG);
	var objControlMonthLeftTD = document.createElement("td");
	objControlMonthLeftTD.className = this.arConfig.css.controlmonthleftTD;
	objControlMonthLeftTD.objMaster = this;
	objControlMonthLeftTD.onclick = function(){
		this.objMaster.objDate.DecMonth();
		this.objMaster.objCNT.objControlYearMonthCenterTD.innerHTML = this.objMaster.arConfig.month[this.objMaster.objDate.intMonth - 1] + "&nbsp;" + this.objMaster.objDate.intYear;
		this.objMaster.GetDaysData();
//		this.objMaster.objParent.SetDate(this.objMaster.objDate);
	}
	objControlYearMonthTR.appendChild(objControlMonthLeftTD);
	var objControlMonthLeftIMG = document.createElement("img");
	objControlMonthLeftIMG.className = this.arConfig.css.controlmonthleftIMG;
	objControlMonthLeftIMG.src = this.arConfig.paths.path2images + "cal_controlmonthleft.gif";
	objControlMonthLeftTD.appendChild(objControlMonthLeftIMG);
	var objControlYearMonthCenterTD = document.createElement("td");
	objControlYearMonthCenterTD.className = this.arConfig.css.controlyearmonthcenterTD;
	objControlYearMonthCenterTD.innerHTML = this.arConfig.month[this.objDate.intMonth - 1] + "&nbsp;" + this.objDate.intYear;
	objControlYearMonthTR.appendChild(objControlYearMonthCenterTD);
	this.objCNT.objControlYearMonthCenterTD = objControlYearMonthCenterTD;
	var objControlMonthRightTD = document.createElement("td");
	objControlMonthRightTD.className = this.arConfig.css.controlmonthrightTD;
	objControlMonthRightTD.objMaster = this;
	objControlMonthRightTD.onclick = function(){
		this.objMaster.objDate.IncMonth();
		this.objMaster.objCNT.objControlYearMonthCenterTD.innerHTML = this.objMaster.arConfig.month[this.objMaster.objDate.intMonth - 1] + "&nbsp;" + this.objMaster.objDate.intYear;
		this.objMaster.GetDaysData();
//		this.objMaster.objParent.SetDate(this.objMaster.objDate);
	}
	objControlYearMonthTR.appendChild(objControlMonthRightTD);
	var objControlMonthRightIMG = document.createElement("img");
	objControlMonthRightIMG.className = this.arConfig.css.controlmonthrightIMG;
	objControlMonthRightIMG.src = this.arConfig.paths.path2images + "cal_controlmonthright.gif";
	objControlMonthRightTD.appendChild(objControlMonthRightIMG);
	var objControlYearRightTD = document.createElement("td");
	objControlYearRightTD.className = this.arConfig.css.controlyearrightTD;
	objControlYearRightTD.objMaster = this;
	objControlYearRightTD.onclick = function(){
		this.objMaster.objDate.IncYear();
		this.objMaster.objCNT.objControlYearMonthCenterTD.innerHTML = this.objMaster.arConfig.month[this.objMaster.objDate.intMonth - 1] + "&nbsp;" + this.objMaster.objDate.intYear;
		this.objMaster.GetDaysData();
//		this.objMaster.objParent.SetDate(this.objMaster.objDate);
	}
	objControlYearMonthTR.appendChild(objControlYearRightTD);
	var objControlYearRightIMG = document.createElement("img");
	objControlYearRightIMG.className = this.arConfig.css.controlyearrightIMG;
	objControlYearRightIMG.src = this.arConfig.paths.path2images + "cal_controlyearright.gif";
	objControlYearRightTD.appendChild(objControlYearRightIMG);
	var objControlDayTR = document.createElement("tr");
	objControlDayTR.className = this.arConfig.css.controldayTR;
	objMainTBO.appendChild(objControlDayTR);
	var objControlDayLeftTD = document.createElement("td");
	objControlDayLeftTD.colSpan = 2;
	objControlDayLeftTD.className = this.arConfig.css.controldayleftTD;
	objControlDayLeftTD.objMaster = this;
	objControlDayLeftTD.onclick = function(){
		this.objMaster.objDate.DecDay();
		this.objMaster.objCNT.objControlYearMonthCenterTD.innerHTML = this.objMaster.arConfig.month[this.objMaster.objDate.intMonth - 1] + "&nbsp;" + this.objMaster.objDate.intYear;
		this.objMaster.GetDaysData();
//		this.objMaster.objParent.SetDate(this.objMaster.objDate);
	}
	objControlDayTR.appendChild(objControlDayLeftTD);
	var objControlDayLeftIMG = document.createElement("img");
	objControlDayLeftIMG.className = this.arConfig.css.controldayleftIMG;
	objControlDayLeftIMG.src = this.arConfig.paths.path2images + "cal_controldayleft.gif";
	objControlDayLeftTD.appendChild(objControlDayLeftIMG);
	var objControlDayCenterTD = document.createElement("td");
	objControlDayCenterTD.className = this.arConfig.css.controldaycenterTD;
	objControlDayCenterTD.innerHTML = this.arConfig.today;
	objControlDayCenterTD.objMaster = this;
	objControlDayCenterTD.onclick = function(){
		this.objMaster.objDate = new DateType(this.objMaster.objToday.intYear + "-" + this.objMaster.objToday.intMonth + "-" + this.objMaster.objToday.intDay);
		this.objMaster.objCNT.objControlYearMonthCenterTD.innerHTML = this.objMaster.arConfig.month[this.objMaster.objDate.intMonth - 1] + "&nbsp;" + this.objMaster.objDate.intYear;
		this.objMaster.GetDaysData();
//		this.objMaster.objParent.SetDate(this.objMaster.objDate);
	}
	objControlDayTR.appendChild(objControlDayCenterTD);
	var objControlDayRightTD = document.createElement("td");
	objControlDayRightTD.colSpan = 2;
	objControlDayRightTD.className = this.arConfig.css.controldayrightTD;
	objControlDayRightTD.objMaster = this;
	objControlDayRightTD.onclick = function(){
		this.objMaster.objDate.IncDay();
		this.objMaster.objCNT.objControlYearMonthCenterTD.innerHTML = this.objMaster.arConfig.month[this.objMaster.objDate.intMonth - 1] + "&nbsp;" + this.objMaster.objDate.intYear;
		this.objMaster.GetDaysData();
//		this.objMaster.objParent.SetDate(this.objMaster.objDate);
	}
	objControlDayTR.appendChild(objControlDayRightTD);
	var objControlDayRightIMG = document.createElement("img");
	objControlDayRightIMG.className = this.arConfig.css.controldayrightIMG;
	objControlDayRightIMG.src = this.arConfig.paths.path2images + "cal_controldayright.gif";
	objControlDayRightTD.appendChild(objControlDayRightIMG);
	var objCalendarTR = document.createElement("tr");
	objCalendarTR.className = this.arConfig.css.calendarTR;
	objMainTBO.appendChild(objCalendarTR);
	var objCalendarTD = document.createElement("td");
	objCalendarTD.colSpan = 5;
	objCalendarTD.className = this.arConfig.css.calendarTD;
	objCalendarTR.appendChild(objCalendarTD);
	var objCalendarTBL = document.createElement("table");
	objCalendarTBL.cellPadding = 0;
	objCalendarTBL.cellSpacing = 0;
	objCalendarTBL.className = this.arConfig.css.calendarTBL;
	objCalendarTD.appendChild(objCalendarTBL);
	objCalendarTBL.appendChild(document.createElement("thead"));
	objCalendarTBL.appendChild(document.createElement("tfoot"));
	var objCalendarTBO = document.createElement("tbody");
	objCalendarTBO.makeEmpty = function(){
		while(this.childNodes.length > 1){
			this.removeChild(this.childNodes[1]);
		}
	}
	objCalendarTBL.appendChild(objCalendarTBO);
	this.objCNT.objCalendarTBO = objCalendarTBO;
	var objWeekdayTR = document.createElement("tr");
	objWeekdayTR.className = this.arConfig.css.weekdayTR;
	objCalendarTBO.appendChild(objWeekdayTR);
	for(var i = 0; i < 8; i++){
		var objTD = document.createElement("td");
		objTD.className = this.arConfig.css.weekdayTD + " " + this.arConfig.css.weekdayTD + i;
		objWeekdayTR.appendChild(objTD);
		var objTXT = document.createTextNode((i == 0 ? this.arConfig.calweek : this.arConfig.weekday[i - 1]));
		objTD.appendChild(objTXT);
	}
	this.GetDaysData = function(){
		this.GotDaysData(new Array());
	}
	this.GotDaysData = function(arDays){
		this.objCNT.objCalendarTBO.makeEmpty();
		var objStart = new DateType(this.objDate.intYear + "-" + this.objDate.intMonth + "-01");
		var objTravel = new DateType(this.objDate.intYear + "-" + this.objDate.intMonth + "-01");
		var objEnd = new DateType(this.objDate.intYear + "-" + this.objDate.intMonth + "-" + this.objDate.GetLastDayOfMonth());
		var intCount = 0;
		var objTR;
		var objTD;
		var objTXT;
		for(var i = 2 - objStart.intWeekDay; i < this.objDate.GetMonthDays() - objEnd.intWeekDay + 8; i++){
			if(intCount % 7 == 0){
				objTR = document.createElement("tr");
				objTR.className = this.arConfig.css.datesTR;
				this.objCNT.objCalendarTBO.appendChild(objTR);
				objTD = document.createElement("td");
				objTD.className = this.arConfig.css.calweekTD;
				objTR.appendChild(objTD);
				objTXT = document.createTextNode(objTravel.intCalendarWeek);
				objTD.appendChild(objTXT);
			}
			objTD = document.createElement("td");
			objTD.objMaster = this;
			objTD.intDay = objTravel.intDay;
			objTD.intPos = intCount % 7;
			objTR.appendChild(objTD);
			if(i > 0 && i <= this.objDate.GetMonthDays()){
				var boolFound = false;
				for(var j = 0; j < arDays.length; j++){
					if(arDays[j] == objTravel.intDay){
						boolFound = true;
						break;
					}
				}
				if(boolFound){
					if(this.objDate.intDay == objTravel.intDay){
						objTD.className = this.arConfig.css.seldatesTD + " " + this.arConfig.css.seldatesTD + (intCount % 7);
						objTD.onclick = function(){
							this.objMaster.objDate = new DateType(this.objMaster.objDate.intYear + "-" + this.objMaster.objDate.intMonth + "-" + this.intDay);
							this.objMaster.objParent.SetDate(this.objMaster.objDate);
						}
						objTD.onmouseover = function(){
							this.className = this.objMaster.arConfig.css.overseldatesTD + " " + this.objMaster.arConfig.css.overseldatesTD + this.intPos;
						}
						objTD.onmouseout = function(){
							this.className = this.objMaster.arConfig.css.seldatesTD + " " + this.objMaster.arConfig.css.seldatesTD + this.intPos;
						}
					}
					else{
						objTD.className = this.arConfig.css.datesTD + " " + this.arConfig.css.datesTD + (intCount % 7);
						objTD.onclick = function(){
							this.objMaster.objDate = new DateType(this.objMaster.objDate.intYear + "-" + this.objMaster.objDate.intMonth + "-" + this.intDay);
							this.objMaster.objParent.SetDate(this.objMaster.objDate);
						}
						objTD.onmouseover = function(){
							this.className = this.objMaster.arConfig.css.overdatesTD + " " + this.objMaster.arConfig.css.overdatesTD + this.intPos;
						}
						objTD.onmouseout = function(){
							this.className = this.objMaster.arConfig.css.datesTD + " " + this.objMaster.arConfig.css.datesTD + this.intPos;
						}
					}
				}
				else{
					if(this.objDate.intDay == objTravel.intDay){
						objTD.className = this.arConfig.css.selnodatesTD + " " + this.arConfig.css.selnodatesTD + (intCount % 7);
						objTD.onclick = function(){
							this.objMaster.objDate = new DateType(this.objMaster.objDate.intYear + "-" + this.objMaster.objDate.intMonth + "-" + this.intDay);
							this.objMaster.objParent.SetDate(this.objMaster.objDate);
						}
						objTD.onmouseover = function(){
							this.className = this.objMaster.arConfig.css.overselnodatesTD + " " + this.objMaster.arConfig.css.overselnodatesTD + this.intPos;
						}
						objTD.onmouseout = function(){
							this.className = this.objMaster.arConfig.css.selnodatesTD + " " + this.objMaster.arConfig.css.selnodatesTD + this.intPos;
						}
					}
					else{
						objTD.className = this.arConfig.css.nodatesTD + " " + this.arConfig.css.nodatesTD + (intCount % 7);
						objTD.onclick = function(){
							this.objMaster.objDate = new DateType(this.objMaster.objDate.intYear + "-" + this.objMaster.objDate.intMonth + "-" + this.intDay);
							this.objMaster.objParent.SetDate(this.objMaster.objDate);
						}
						objTD.onmouseover = function(){
							this.className = this.objMaster.arConfig.css.overnodatesTD + " " + this.objMaster.arConfig.css.overnodatesTD + this.intPos;
						}
						objTD.onmouseout = function(){
							this.className = this.objMaster.arConfig.css.nodatesTD + " " + this.objMaster.arConfig.css.nodatesTD + this.intPos;
						}
					}
				}
				objTXT = document.createTextNode(objTravel.intDay);
				objTravel.IncDay();
				objTD.appendChild(objTXT);
			}
			else{
				objTD.innerHTML = "&nbsp;";
				objTD.className = this.arConfig.css.nodataTD + " " + this.arConfig.css.nodataTD + (intCount % 7);
			}
			intCount++;
		}
	}
	this.GetDaysData();
}
var objCalendar = new Object();
function ShowCalendar(objTarget,strDate){
	strDate = strDate.substr(6,4) + "-" + strDate.substr(3,2) + "-" + strDate.substr(0,2);
	if(objCalendar instanceof CalendarPOP)objCalendar.clear();
	objCalendar = new CalendarPOP(strDate);
	objCalendar.ShowCalendar(objTarget);
}