<?
// ---------------------------------------------------------
// DView 2.1 - 2013-09-01
// www.dview.de
//  2013 Ingmar Ober - www.oberin.de
// Released under the Creative Commons License CC-BY-SA.
// http://creativecommons.org/licenses/by-sa/3.0/deed.de
// ---------------------------------------------------------
error_reporting(E_ALL);
include ("../../config/ini.main.php");
require_once("media.php");
if(isset($_REQUEST["ImageFilePath"])){
	$_REQUEST["File"] = (string)$_REQUEST["ImageFilePath"];
}
else if(isset($_REQUEST["ImageFile"])){
	$_REQUEST["File"] = GetImagePathPHP($_REQUEST["ImageFile"]);
}
else{
	$_REQUEST["File"] = GetMediaPathPHP((int)$_REQUEST["MediaID"]);
}

//Define standard values
//Changeable upon REQUEST
define("STD_OUTPUTTYPE", 0); //Possible values: 0-keep original, 1-GIF, 2-JPG, 3-PNG, 4-WBMP,
define("STD_JPGQUALITY", 100); //Applies only for STD_OUTPUTTYPE = 2; possible values: 0-100
define("STD_MINWIDTH", 0); // 0 means no restriction
define("STD_MINHEIGHT", 0); // 0 means no restriction
define("STD_MAXWIDTH", 0); // 0 means no restriction
define("STD_MAXHEIGHT", 0); // 0 means no restriction
define("STD_PASSEPARTOUT", false);
define("STD_KEEPBGTRANSPARENCY", true); //Preserves the given bg-color and transparency
define("STD_BGCOLOR", "F9F9F9");
define("STD_BGTRANSPARENT", false); //Applies only for STD_OUTPUTTYPE = 1 AND 3
define("STD_INTERLACE", false);
//Fixed values
define("OUTPUTTYPEORDER", "2134"); //See STD_OUTPUTTYPE
define("DONOTCACHE", true);
define("SHOWLOGOONERROR", true);
define("LOGOCOLOR", "CCCCCC");
define("SHOWERROR", true);
define("COLOROFFSET", 30);

//Get infos about the currently used GD-library
if(function_exists("gd_info")){
	$arGDInfo = gd_info();
}
else{
	$arGDInfo = array("GD Version" => "", "FreeType Support" => false, "FreeType Linkage" => "", "T1Lib Support" => false, "GIF Read Support" => false, "GIF Create Support" => false, "JPG Support" => false, "PNG Support" => false, "WBMP Support" => false, "XBM Support" => false);
	ob_start();
	phpinfo();
	$strPHPInfo = ob_get_contents();
	ob_end_clean();
	preg_match_all("#(gd.version|freetype.support|freetype.linkage|t1lib.support|gif.support|gif.read.support|gif.create.support|jpg.support|png.support|wbmp.support|xbm.support)(.*?)\n#i", $strPHPInfo, $arMatches = array(), PREG_SET_ORDER);
	foreach($arMatches as $arMatch){
		if(strtoupper($arMatch[1]) == "GIF SUPPORT" && strtoupper(trim(strip_tags($arMatch[2]))) == "ENABLED"){
			$arGDInfo["GIF Read Support"] = true;
			$arGDInfo["GIF Create Support"] = true;
		}
		else if(strtoupper(trim(strip_tags($arMatch[2]))) == "ENABLED"){
			foreach($arGDInfo as $strKey => $varValue){
				if(strtoupper($strKey) == strtoupper($arMatch[1])){
					$arGDInfo[$strKey] = true;
				}
			}
		}
		else if(strtoupper($arMatch[1]) == "GD VERSION"){
			$arGDInfo["GD Version"] = trim(strip_tags($arMatch[2]));
		}
	}
}
if($arGDInfo["GD Version"] != ""){
	$arMatch = array();
	preg_match("#(\d+)\.?(\d*)\.?(\d*)#i", $arGDInfo["GD Version"], $arMatch);
	$arGDInfo["GD Version High"] = (int)$arMatch[1];
	$arGDInfo["GD Version Mid"] = (int)$arMatch[2];
	$arGDInfo["GD Version Low"] = (int)$arMatch[3];
	$arGDInfo["True Color"] = false;
	if(((int)$arGDInfo["GD Version High"]) > 1) $arGDInfo["True Color"] = true;
	$intError = 0;
	$strError = "";
	$strOutputType = "";
	$strOutputTypeOrder = OUTPUTTYPEORDER;
	if(!isset($arGDInfo["GIF Create Support"])) $strOutputTypeOrder = str_replace("1", "", $strOutputTypeOrder);
	if(!isset($arGDInfo["JPG Support"])) $strOutputTypeOrder = str_replace("2", "", $strOutputTypeOrder);
	if(!isset($arGDInfo["PNG Support"])) $strOutputTypeOrder = str_replace("3", "", $strOutputTypeOrder);
	if(!isset($arGDInfo["WBMP Support"])) $strOutputTypeOrder = str_replace("4", "", $strOutputTypeOrder);
	if(!isset($arGDInfo["XBM Support"])) $strOutputTypeOrder = str_replace("5", "", $strOutputTypeOrder);
	if(strlen($strOutputTypeOrder) == 0){
		header($_SERVER["SERVER_PROTOCOL"]." 404 File not found");
		exit();
	}
	//Set parameters
	$intOutputType = (int)(isset($_REQUEST["OutputType"]) ? $_REQUEST["OutputType"] : STD_OUTPUTTYPE);
	$intJPGQuality = (int)(isset($_REQUEST["JPGQuality"]) ? $_REQUEST["JPGQuality"] : STD_JPGQUALITY);
	$intMinWidth = (int)(isset($_REQUEST["MinWidth"]) ? $_REQUEST["MinWidth"] : STD_MINWIDTH);
	$intMinHeight = (int)(isset($_REQUEST["MinHeight"]) ? $_REQUEST["MinHeight"] : STD_MINHEIGHT);
	$intMaxWidth = (int)(isset($_REQUEST["MaxWidth"]) ? $_REQUEST["MaxWidth"] : STD_MAXWIDTH);
	$intMaxHeight = (int)(isset($_REQUEST["MaxHeight"]) ? $_REQUEST["MaxHeight"] : STD_MAXHEIGHT);
	$boolPassepartout = (bool)(isset($_REQUEST["Passepartout"]) ? $_REQUEST["Passepartout"] : STD_PASSEPARTOUT);
	$intInterlace = (int)((bool)(isset($_REQUEST["Interlace"]) ? $_REQUEST["Interlace"] : STD_INTERLACE));
	$strBGColor = (string)(isset($_REQUEST["BGColor"]) ? $_REQUEST["BGColor"] : STD_BGCOLOR);
	if(strlen($strBGColor) != 6 && strlen($strBGColor) != 3){
		$strBGColor = STD_BGCOLOR;
	}
	if(strlen($strBGColor) == 3){
		$strTemp = "";
		$strTemp = str_repeat(substr($strBGColor, 0, 1), 2);
		$strTemp .= str_repeat(substr($strBGColor, 1, 1), 2);
		$strTemp .= str_repeat(substr($strBGColor, 2, 1), 2);
		$strBGColor = $strTemp;
	}
	$intBGColorR=hexdec(substr($strBGColor,0,2));
	$intBGColorG=hexdec(substr($strBGColor,2,2));
	$intBGColorB=hexdec(substr($strBGColor,4,2));
	$boolBGTransparent = (bool)(isset($_REQUEST["BGTransparent"]) ? $_REQUEST["BGTransparent"] : STD_BGTRANSPARENT);
	$boolInterlace = (bool)(isset($_REQUEST["Interlace"]) ? $_REQUEST["Interlace"] : STD_INTERLACE);
	$boolKeepTransparency = false;
	//Check parameters
	if($intOutputType == "") $intOutputType = 0;
	if(strpos($strOutputTypeOrder, (string)$intOutputType) === false){
		$intOutputType = (int)substr($strOutputType, 0, 1);
	}
	if($intJPGQuality < 0) $intJPGQuality = 0;
	if($intJPGQuality > 100) $intJPGQuality = 100;
	if($intMinWidth < 0) $intMinWidth = 0;
	if($intMinHeight < 0) $intMinHeight = 0;
	if($intMaxWidth < 0) $intMaxWidth = 0;
	if($intMaxHeight < 0) $intMaxHeight =0;
	if($intBGColorR < 0) $intBGColorR = 0;
	if($intBGColorR > 255) $intBGColorR = 255;
	if($intBGColorG < 0) $intBGColorG = 0;
	if($intBGColorG > 255) $intBGColorG = 255;
	if($intBGColorB < 0) $intBGColorB = 0;
	if($intBGColorB > 255) $intBGColorB = 255;
	//Get file and file-infos
	$strFilePath = $_REQUEST["File"];
	$strFileName = substr($strFilePath,strrpos($strFilePath,"/"));
	$strFileName = preg_replace("/\//","",$strFileName);
	$resSourceImage = false;
	if(file_exists($strFilePath)){
		$arFileInfo = getimagesize($strFilePath);
		$intSourceType = 0;
		switch($arFileInfo[2]){
			case 1:
				// GIF
				if($arGDInfo["GIF Read Support"]){
					$resSourceImage = @imagecreatefromgif($strFilePath);
					$intSourceType = 1;
					if(STD_KEEPBGTRANSPARENCY){
						$resTCheck = fopen($strFilePath, "rb");
						$strGIFInfo = fread($resTCheck, 13);
						$boolKeepTransparency = (bool)((ord(substr($strGIFInfo, 10, 1)) & 128) == 128);
						fclose($resTCheck);
					}
				}
				break;
			case 2:
				//JPEG
				if(isset($arGDInfo["JPG Support"]) || isset($arGDInfo["JPEG Support"])){
					$resSourceImage = @imagecreatefromjpeg($strFilePath);
					$intSourceType = 2;
				}
				break;
			case 3:
				//PNG
				if(isset($arGDInfo["PNG Support"])){
					$resSourceImage = @imagecreatefrompng($strFilePath);
					$intSourceType = 3;
				}
				break;
			case 15:
				//WBMP
				if(isset($arGDInfo["WBMP Support"])){
					$resSourceImage = @imagecreatefromwbmp($strFilePath);
					$intSourceType = 4;
				}
				break;
			case 16:
				//XBM
				if(isset($arGDInfo["XBM Support"])){
					$resSourceImage = @imagecreatefromxbm($strFilePath);
					$intSourceType = 5;
				}
				break;
		}
		if(!$resSourceImage){
			$intError = 2;
			$strError = "Not supported!";
		}
		else{
			if($intOutputType == 0) $intOutputType = $intSourceType;
			$intDestWidth = $intSourceWidth = imagesx($resSourceImage);
			$intDestHeight = $intSourceHeight = imagesy($resSourceImage);
			if($intMaxWidth == 0) $intMaxWidth = $intDestWidth;
			if($intMaxHeight == 0) $intMaxHeight = $intDestHeight;
			//Calculate new size
			$dblAspectRatio = 1;
			$intClipping = 0;
			if($intMinWidth > $intDestWidth || $intMinHeight > $intDestHeight){
				$dblWidthAspectRatio = $intMinWidth / $intDestWidth;
				$dblHeightAspectRatio = $intMinHeight / $intDestHeight;
				if($dblWidthAspectRatio > $dblHeightAspectRatio){
					$dblAspectRatio = $dblWidthAspectRatio;
					$intClipping = 1;
				}
				else if($dblWidthAspectRatio < $dblHeightAspectRatio){
					$dblAspectRatio = $dblHeightAspectRatio;
					$intClipping = 2;
				}
				else{
					$intClipping = 3;
				}
				switch($intClipping){
					case 1:
						$intDestWidth = $intMinWidth;
						$intDestHeight = floor($intDestHeight * $dblAspectRatio);
						break;
					case 2:
						$intDestWidth = floor($intDestWidth * $dblAspectRatio);
						$intDestHeight = $intMinHeight;
						break;
					case 3:
						$intDestWidth = $intMinWidth;
						$intDestHeight = $intMinHeight;
						break;
				}
			}
			if($intMaxWidth < $intDestWidth || $intMaxHeight < $intDestHeight){
				$dblWidthAspectRatio = $intMaxWidth / $intDestWidth;
				$dblHeightAspectRatio = $intMaxHeight / $intDestHeight;
				if($intMaxWidth == 0) $dblWidthAspectRatio = 1;
				if($intMaxHeight == 0) $dblHeightAspectRatio = 1;
				if($dblWidthAspectRatio < $dblHeightAspectRatio){
					$dblAspectRatio = $dblWidthAspectRatio;
					$intClipping = 1;
				}
				else if($dblWidthAspectRatio > $dblHeightAspectRatio){
					$dblAspectRatio = $dblHeightAspectRatio;
					$intClipping = 2;
				}
				else{
					$intClipping = 3;
				}
				switch($intClipping){
					case 1:
						$intDestWidth = $intMaxWidth;
						$intDestHeight = floor($intDestHeight * $dblAspectRatio);
						break;
					case 2:
						$intDestWidth = floor($intDestWidth * $dblAspectRatio);
						$intDestHeight = $intMaxHeight;
						break;
					case 3:
						$intDestWidth = $intMaxWidth;
						$intDestHeight = $intMaxHeight;
						break;
				}
			}
			//Make new image
			if($boolPassepartout){
				$resDestImage = $arGDInfo["True Color"] ? imagecreatetruecolor($intMaxWidth, $intMaxHeight) : imagecreate($intMaxWidth, $intMaxHeight);
				$intWidth = $intMaxWidth;
				$intHeight = $intMaxHeight;
			}
			else{
				$resDestImage = $arGDInfo["True Color"] ? imagecreatetruecolor($intDestWidth, $intDestHeight) : imagecreate($intDestWidth, $intDestHeight);
				$intWidth = $intDestWidth;
				$intHeight = $intDestHeight;
			}
			//Copy palette
			$boolDrawBG = true;
			if(imagecolorstotal($resSourceImage) > 0){
				// Keep transparency
				if($boolKeepTransparency){
					// Check color collision
					$intTransparentIndex = -1;
					$arColors = array();
					for($intIndex = 0; $intIndex < imagecolorstotal($resSourceImage); $intIndex++){
						$arColors[$intIndex] = imagecolorsforindex($resSourceImage, $intIndex);
						if((int)$arColors[$intIndex]["alpha"] == 127) $intTransparentIndex = $intIndex;
					}
					foreach($arColors as $arColor){
						if($arColor["alpha"] == 0) imagecolorallocate($resDestImage, $arColor["red"], $arColor["green"], $arColor["blue"]);
					}
					if($intTransparentIndex > -1){
						unset($arColors[$intTransparentIndex]);
						$arColors[count($arColors)] = array("red" => 0, "green" => 0, "blue" => 0, "alpha" => 0);
						$boolBGTransparent = true;
						$intBGColorR = (int)$arColors[$intTransparentIndex]["red"];
						$intBGColorG = (int)$arColors[$intTransparentIndex]["green"];
						$intBGColorB = (int)$arColors[$intTransparentIndex]["blue"];
						$boolFoundFreeColor = false;
						while(!$boolFoundFreeColor){
							$boolFoundFreeColor = true;
							foreach($arColors as $intKey => $arColor){
								$boolRM = (((int)$arColor["red"]) - COLOROFFSET < $intBGColorR ? true : false);
								$boolRP = (((int)$arColor["red"]) + COLOROFFSET > $intBGColorR ? true : false);
								$boolGM = (((int)$arColor["green"]) - COLOROFFSET < $intBGColorG ? true : false);
								$boolGP = (((int)$arColor["green"]) + COLOROFFSET > $intBGColorG ? true : false);
								$boolBM = (((int)$arColor["blue"]) - COLOROFFSET < $intBGColorB ? true : false);
								$boolBP = (((int)$arColor["blue"]) + COLOROFFSET > $intBGColorB ? true : false);
								if($boolRM && $boolRP && $boolGM && $boolGP && $boolBM && $boolBP){
									$boolFoundFreeColor = false;
									break;
								}
							}
							$intBGColorR++;
							if($intBGColorR > 255){
								$intBGColorG++;
								$intBGColorR = 0;
							}
							if($intBGColorG > 255){
								$intBGColorB++;
								$intBGColorG = 0;
							}
							if($intBGColorB > 255){
								$intBGColorB = 0;
							}
						}
					}
				}
				else{
					imagepalettecopy($resDestImage, $resSourceImage);
				}
			}
			//Fill background
			$colBackground = imagecolorallocate($resDestImage, $intBGColorR, $intBGColorG, $intBGColorB);
			imagefill($resDestImage, 0, 0, $colBackground);
			//Copy and resize image
			if($boolPassepartout){
				imagecopyresized($resDestImage, $resSourceImage, floor(($intMaxWidth - $intDestWidth) / 2), floor(($intMaxHeight - $intDestHeight) / 2), 0, 0, $intDestWidth, $intDestHeight, $intSourceWidth, $intSourceHeight);
			}
			else{
				imagecopyresized($resDestImage, $resSourceImage, 0, 0, 0, 0, $intDestWidth, $intDestHeight, $intSourceWidth, $intSourceHeight);
			}
			imagedestroy($resSourceImage);
			imageinterlace($resDestImage, $intInterlace);
			if(imagecolorstotal($resDestImage) == 0 && $intOutputType == 1){
				if($boolPassepartout){
					$resTempImage = $arGDInfo["True Color"] ? imagecreatetruecolor($intMaxWidth, $intMaxHeight) : imagecreate($intMaxWidth, $intMaxHeight);
				}
				else{
					$resTempImage = $arGDInfo["True Color"] ? imagecreatetruecolor($intDestWidth, $intDestHeight) : imagecreate($intDestWidth, $intDestHeight);
				}
				imagecopymerge($resTempImage, $resDestImage, 0, 0, 0, 0, ($boolPassepartout ? $intMaxWidth : $intDestWidth), ($boolPassepartout ? $intMaxHeight : $intDestHeight), 100);
				imagetruecolortopalette($resDestImage,false,256);
				if((int)$arGDInfo["GD Version High"] > 2 || ((int)$arGDInfo["GD Version High"] == 2 && ((int)$arGDInfo["GD Version Mid"] > 0 || ((int)$arGDInfo["GD Version Mid"] == 0 && (int)$arGDInfo["GD Version Low"] >= 1)))){
					imagecolormatch($resTempImage, $resDestImage);
				}
				imagedestroy($resTempImage);
			}
			if($boolBGTransparent && ($intOutputType == 1 || $intOutputType == 3)){
				$colTransparent = imagecolorexact($resDestImage, $intBGColorR, $intBGColorG, $intBGColorB);
				if($colTransparent == -1){
					$colTransparent = imagecolorclosest($resDestImage, $intBGColorR, $intBGColorG, $intBGColorB);
				}
				imagecolortransparent($resDestImage, $colTransparent);
			}
			//Output Image
			header("Expires: " . gmdate("D, d M Y H:i:s", strtotime("-1 minute")) . " GMT");
			if(DONOTCACHE){
				header("Last-Modified: " . gmdate("D, d M Y H:i:s", strtotime("-1 minute")) . " GMT");
			}
			else{
				header("Last-Modified: " . gmdate("D, d M Y H:i:s", filemtime($strFilePath)) . " GMT");
			}
			header("Cache-Control: must-revalidate");
			header("Cache-Control: post-check=0, pre-check=0", false);
			switch($intOutputType){
				case 1:
					header("Content-Type: image/gif");
					header("Content-Disposition: inline; filename=\"".$strFileName.".gif\"");
					imagegif($resDestImage);
					break;
				case 2:
					header("Content-Type: image/jpeg");
					header("Content-Disposition: inline; filename=\"".$strFileName.".jpg\"");
					imagejpeg($resDestImage, null, $intJPGQuality);
					break;
				case 3:
					header("Content-Type: image/png");
					header("Content-Disposition: inline; filename=\"".$strFileName.".png\"");
					imagepng($resDestImage);
					break;
				case 4:
					header("Content-Type: image/vnd.wap.wbmp");
					header("Content-Disposition: inline; filename=\"".$strFileName.".wbmp\"");
					imagewbmp($resDestImage);
					break;
			}
			imagedestroy($resDestImage);
		}
	}
	else{
		$intError = 1;
		$strError = "File not found!";
	}
	if($intError > 0){
		//Create error-image
		$intDestWidth = $intMaxWidth;
		$intDestHeight = $intMaxHeight;
		if($intMaxWidth == 0) $intDestWidth = 1;
		if($intMaxHeight == 0) $intDestHeight = 1;
		$resDestImage = $arGDInfo["True Color"] ? imagecreatetruecolor($intDestWidth, $intDestHeight) : imagecreate($intDestWidth, $intDestHeight);
		$colBackground = imagecolorallocate($resDestImage, $intBGColorR, $intBGColorG, $intBGColorB);
		imagefill($resDestImage, 0, 0, $colBackground);
		if($intDestWidth >= 100 && $intDestHeight >= 100 && (SHOWLOGOONERROR || SHOWERROR)){
			$strLogoColor = LOGOCOLOR;
			if(strlen($strLogoColor) != 6 && strlen($strLogoColor) != 3){
				$strLogoColor = "000000";
			}
			if(strlen($strLogoColor) == 3){
				$strTemp = "";
				$strTemp = str_repeat(substr($strLogoColor, 0, 1), 2);
				$strTemp .= str_repeat(substr($strLogoColor, 1, 1), 2);
				$strTemp .= str_repeat(substr($strLogoColor, 2, 1), 2);
				$strLogoColor = $strTemp;
			}
		  $intLogoColorR=hexdec(substr($strLogoColor,0,2));
		  $intLogoColorG=hexdec(substr($strLogoColor,2,2));
		  $intLogoColorB=hexdec(substr($strLogoColor,4,2));
			if($intLogoColorR < 0) $intLogoColorR = 0;
			if($intLogoColorR > 255) $intLogoColorR = 255;
			if($intLogoColorG < 0) $intLogoColorG = 0;
			if($intLogoColorG > 255) $intLogoColorG = 255;
			if($intLogoColorB < 0) $intLogoColorB = 0;
			if($intLogoColorB > 255) $intLogoColorB = 255;
			$colLogoColor = imagecolorallocate($resDestImage, $intLogoColorR, $intLogoColorG, $intLogoColorB);
			imagesetthickness($resDestImage, 10);
			imagearc($resDestImage, floor($intDestWidth / 2), floor($intDestHeight / 2), 100, 100, 200, 340, $colLogoColor);
			imagearc($resDestImage, floor($intDestWidth / 2), floor($intDestHeight / 2), 100, 100, 20, 160, $colLogoColor);
			imagestring($resDestImage, 5, floor(($intDestWidth - (strlen($strError) * 9)) / 2), floor($intDestHeight /2) - 8, $strError, $colLogoColor);
		}
		if($boolBGTransparent && ($intOutputType == 1 || $intOutputType == 3)){
			$colTransparent = imagecolorexact($resDestImage, $intBGColorR, $intBGColorG, $intBGColorB);
			if($colTransparent == -1){
				$colTransparent = imagecolorclosest($resDestImage, $intBGColorR, $intBGColorG, $intBGColorB);
			}
			imagecolortransparent($resDestImage, $colTransparent);
		}
		//Output Image
		header("Expires: " . gmdate("D, d M Y H:i:s", strtotime("-1 minute")) . " GMT");
		header("Last-Modified: " . gmdate("D, d M Y H:i:s", strtotime("-1 minute")) . " GMT");
		header("Cache-Control: must-revalidate");
		header("Cache-Control: post-check=0, pre-check=0", false);
		switch($intOutputType){
			case 1:
				header("Content-Type: image/gif");
				header("Content-Disposition: inline; filename=\"".$strFileName.".gif\"");
				imagegif($resDestImage);
				break;
			case 2:
				header("Content-Type: image/jpeg");
				header("Content-Disposition: inline; filename=\"".$strFileName.".jpg\"");
				imagejpeg($resDestImage, null, $intJPGQuality);
				break;
			case 3:
				header("Content-Type: image/png");
				header("Content-Disposition: inline; filename=\"".$strFileName.".png\"");
				imagepng($resDestImage);
				break;
			case 4:
				header("Content-Type: image/vnd.wap.wbmp");
				header("Content-Disposition: inline; filename=\"".$strFileName.".wbmp\"");
				imagewbmp($resDestImage);
				break;
		}
		imagedestroy($resDestImage);
	}
}
else{
	header($_SERVER["SERVER_PROTOCOL"]." 404 File not found");
}
?>