--
-- Tabellenstruktur fr Tabelle dv_admin_menu
--

CREATE TABLE IF NOT EXISTS dv_admin_menu (
  MenuID int(10) unsigned NOT NULL auto_increment,
  MenuState enum('active','inactive','locked') NOT NULL default 'active',
  MenuParentID int(10) unsigned NOT NULL default '0',
  MenuSortNo int(10) unsigned NOT NULL default '1',
  MenuTitle varchar(50) NOT NULL default '',
  MenuDescription varchar(255) NOT NULL default '',
  MenuPageID int(1) NOT NULL default '0',
  MenuVisibility int(1) NOT NULL default '0',
  ChgUser int(5) NOT NULL default '0',
  ChgDatetime datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (MenuID),
  KEY MenuParentID (MenuSortNo)
);

--
-- Daten fr Tabelle dv_admin_menu
--

INSERT INTO dv_admin_menu (MenuID, MenuState, MenuParentID, MenuSortNo, MenuTitle, MenuDescription, MenuPageID, MenuVisibility, ChgUser, ChgDatetime) VALUES(1, 'active', 0, 12, 'Admin Men', '', 54, 1, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_menu (MenuID, MenuState, MenuParentID, MenuSortNo, MenuTitle, MenuDescription, MenuPageID, MenuVisibility, ChgUser, ChgDatetime) VALUES(2, 'active', 0, 13, 'Admin Seiten', '', 39, 1, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_menu (MenuID, MenuState, MenuParentID, MenuSortNo, MenuTitle, MenuDescription, MenuPageID, MenuVisibility, ChgUser, ChgDatetime) VALUES(3, 'active', 0, 8, 'Einstellungen', '', 35, 1, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_menu (MenuID, MenuState, MenuParentID, MenuSortNo, MenuTitle, MenuDescription, MenuPageID, MenuVisibility, ChgUser, ChgDatetime) VALUES(4, 'active', 0, 11, 'Admin Gruppen', '', 32, 1, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_menu (MenuID, MenuState, MenuParentID, MenuSortNo, MenuTitle, MenuDescription, MenuPageID, MenuVisibility, ChgUser, ChgDatetime) VALUES(5, 'active', 0, 10, 'Admin Benutzer', '', 30, 1, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_menu (MenuID, MenuState, MenuParentID, MenuSortNo, MenuTitle, MenuDescription, MenuPageID, MenuVisibility, ChgUser, ChgDatetime) VALUES(6, 'active', 0, 9, 'Admin Passwort', '', 28, 1, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_menu (MenuID, MenuState, MenuParentID, MenuSortNo, MenuTitle, MenuDescription, MenuPageID, MenuVisibility, ChgUser, ChgDatetime) VALUES(8, 'active', 0, 6, 'Seiten', '', 50, 1, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_menu (MenuID, MenuState, MenuParentID, MenuSortNo, MenuTitle, MenuDescription, MenuPageID, MenuVisibility, ChgUser, ChgDatetime) VALUES(23, 'active', 0, 4, 'Aktuelles', '', 9, 1, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_menu (MenuID, MenuState, MenuParentID, MenuSortNo, MenuTitle, MenuDescription, MenuPageID, MenuVisibility, ChgUser, ChgDatetime) VALUES(26, 'active', 0, 3, 'Lauftext', '', 5, 1, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_menu (MenuID, MenuState, MenuParentID, MenuSortNo, MenuTitle, MenuDescription, MenuPageID, MenuVisibility, ChgUser, ChgDatetime) VALUES(27, 'active', 0, 1, 'Start', '', 4, 1, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_menu (MenuID, MenuState, MenuParentID, MenuSortNo, MenuTitle, MenuDescription, MenuPageID, MenuVisibility, ChgUser, ChgDatetime) VALUES(29, 'active', 23, 1, 'Aktuelles Detail', '', 10, 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_menu (MenuID, MenuState, MenuParentID, MenuSortNo, MenuTitle, MenuDescription, MenuPageID, MenuVisibility, ChgUser, ChgDatetime) VALUES(44, 'active', 8, 1, 'Seite Detail', '', 51, 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_menu (MenuID, MenuState, MenuParentID, MenuSortNo, MenuTitle, MenuDescription, MenuPageID, MenuVisibility, ChgUser, ChgDatetime) VALUES(47, 'active', 5, 1, 'Admin Benutzer Detail', '', 31, 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_menu (MenuID, MenuState, MenuParentID, MenuSortNo, MenuTitle, MenuDescription, MenuPageID, MenuVisibility, ChgUser, ChgDatetime) VALUES(48, 'active', 4, 1, 'Admin Gruppe / Rolle Detail', '', 33, 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_menu (MenuID, MenuState, MenuParentID, MenuSortNo, MenuTitle, MenuDescription, MenuPageID, MenuVisibility, ChgUser, ChgDatetime) VALUES(49, 'active', 2, 1, 'Admin Seite Detail', '', 40, 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_menu (MenuID, MenuState, MenuParentID, MenuSortNo, MenuTitle, MenuDescription, MenuPageID, MenuVisibility, ChgUser, ChgDatetime) VALUES(50, 'active', 1, 1, 'Admin Menpunkt Detail', '', 55, 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_menu (MenuID, MenuState, MenuParentID, MenuSortNo, MenuTitle, MenuDescription, MenuPageID, MenuVisibility, ChgUser, ChgDatetime) VALUES(63, 'active', 62, 1, 'Monitor Detail', '', 69, 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_menu (MenuID, MenuState, MenuParentID, MenuSortNo, MenuTitle, MenuDescription, MenuPageID, MenuVisibility, ChgUser, ChgDatetime) VALUES(55, 'active', 0, 7, 'Dateien', '', 60, 1, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_menu (MenuID, MenuState, MenuParentID, MenuSortNo, MenuTitle, MenuDescription, MenuPageID, MenuVisibility, ChgUser, ChgDatetime) VALUES(57, 'active', 55, 1, 'Datei Detail', '', 63, 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_menu (MenuID, MenuState, MenuParentID, MenuSortNo, MenuTitle, MenuDescription, MenuPageID, MenuVisibility, ChgUser, ChgDatetime) VALUES(58, 'active', 4, 2, 'Admin Gruppen / Rollen Seitenzugriffe', '', 64, 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_menu (MenuID, MenuState, MenuParentID, MenuSortNo, MenuTitle, MenuDescription, MenuPageID, MenuVisibility, ChgUser, ChgDatetime) VALUES(59, 'active', 0, 5, 'Vertretungsplan', 'Vertretungsplan', 65, 1, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_menu (MenuID, MenuState, MenuParentID, MenuSortNo, MenuTitle, MenuDescription, MenuPageID, MenuVisibility, ChgUser, ChgDatetime) VALUES(60, 'active', 59, 1, 'Vertretungsplan Detail', 'Vertretungsplan Detail', 66, 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_menu (MenuID, MenuState, MenuParentID, MenuSortNo, MenuTitle, MenuDescription, MenuPageID, MenuVisibility, ChgUser, ChgDatetime) VALUES(61, 'active', 26, 1, 'Lauftext Detail', '', 67, 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_menu (MenuID, MenuState, MenuParentID, MenuSortNo, MenuTitle, MenuDescription, MenuPageID, MenuVisibility, ChgUser, ChgDatetime) VALUES(62, 'active', 0, 2, 'Monitor', '', 68, 1, 1, '2013-11-25 00:00:00');

--
-- Tabellenstruktur fr Tabelle dv_admin_page
--

CREATE TABLE IF NOT EXISTS dv_admin_page (
  AdminPageID int(10) unsigned NOT NULL auto_increment,
  AdminPageMenuID int(10) unsigned NOT NULL default '0',
  AdminPageSortNo int(10) unsigned NOT NULL default '0',
  AdminPageName varchar(50) NOT NULL default '',
  AdminPageTitle varchar(50) NOT NULL default '',
  AdminPageDescription varchar(255) NOT NULL default '',
  AdminPageKeywords varchar(255) NOT NULL default '',
  AdminPageTemplate varchar(50) NOT NULL default '',
  PageHidden tinyint(1) NOT NULL default '0',
  ChgUser int(5) NOT NULL default '0',
  ChgDatetime datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (AdminPageID),
  KEY AdminPageMenuID (AdminPageMenuID),
  KEY AdminPageSortNo (AdminPageSortNo)
);

--
-- Daten fr Tabelle dv_admin_page
--

INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(1, 1, 0, 'Login', 'Login', '', '', 'main_login', 1, 0, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(2, 2, 0, 'Login Falsch', 'Login Falsch', '', '', 'main_login_false', 1, 0, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(3, 3, 0, 'Logout', 'Logout', '', '', 'main_logout', 1, 0, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(4, 4, 1, 'Start', 'Start', '', '', 'main_start', 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(5, 5, 2, 'Lauftext', 'Lauftext', '', '', 'main_scrolltext', 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(9, 9, 4, 'Aktuelles', 'Aktuelles', '', '', 'main_news', 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(10, 10, 5, 'Aktuelles Detail', 'Aktuelles Detail', '', '', 'main_news_detail', 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(28, 28, 14, 'Admin Passwort', 'Admin Passwort', '', '', 'main_user_password', 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(29, 29, 15, 'Admin Passwort Status', 'Admin Passwort Status', '', '', 'main_user_password_stat', 0, 0, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(30, 30, 16, 'Admin Benutzer', 'Admin Benutzer', '', '', 'main_user', 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(31, 31, 18, 'Admin Benutzer Detail', 'Admin Benutzer Detail', '', '', 'main_user_detail', 0, 0, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(32, 32, 17, 'Admin Gruppen / Rollen', 'Admin Gruppen / Rollen', '', '', 'main_usergroups', 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(33, 33, 19, 'Admin Gruppen / Rollen Detail', 'Admin Gruppen / Rollen Detail', '', '', 'main_usergroups_detail', 0, 0, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(35, 35, 13, 'Einstellungen', 'Einstellungen', '', '', 'main_ini', 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(36, 36, 0, 'Zugriff Verweigert', 'Zugriff Verweigert', '', '', 'main_page_denied', 1, 0, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(37, 37, 0, 'Seitenaufteilung Admin', 'Seitenaufteilung Admin', '', '', 'sitesplit', 1, 0, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(39, 39, 21, 'Admin Seiten', 'Admin Seiten', '', '', 'main_adminpages', 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(40, 40, 22, 'Admin Seite Detail', 'Admin Seite Detail', '', '', 'main_adminpages_detail', 0, 0, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(50, 50, 8, 'Seiten', 'Seiten', '', '', 'main_pages', 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(51, 51, 9, 'Seiten Detail', 'Seiten Detail', '', '', 'main_pages_detail', 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(54, 54, 23, 'Admin Menue', 'Admin Menue', '', '', 'main_adminmenu', 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(55, 55, 24, 'Admin Menue Detail', 'Admin Menue Detail', '', '', 'main_adminmenu_detail', 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(60, 60, 10, 'Dateien', 'Dateien', '', '', 'main_media_browser', 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(61, 61, 11, 'Dateien Vollansicht', 'Dateien Vollansicht', '', '', 'main_media_fullview', 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(63, 0, 12, 'Datei Detail', 'Datei Detail', '', '', 'main_media_detail', 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(64, 0, 20, 'Admin Gruppen / Rollen Seitenzugriffe', 'Admin Gruppen / Rollen Seitenzugriffe', '', '', 'main_usergroups_pageaccess', 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(65, 0, 6, 'Vertretungsplne', 'Vertretungsplne', '', '', 'main_substitution', 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(66, 0, 7, 'Vertretungsplan Detail', 'Vertretungsplan Detail', '', '', 'main_substitution_detail', 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(67, 0, 3, 'Lauftext Detail', 'Lauftext Detail', '', '', 'main_scrolltext_detail', 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(68, 0, 25, 'Monitore', 'Monitore', '', '', 'main_display', 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_page (AdminPageID, AdminPageMenuID, AdminPageSortNo, AdminPageName, AdminPageTitle, AdminPageDescription, AdminPageKeywords, AdminPageTemplate, PageHidden, ChgUser, ChgDatetime) VALUES(69, 0, 26, 'Monitor Detail', 'Monitor Detail', '', '', 'main_display_detail', 0, 1, '2013-11-25 00:00:00');

--
-- Tabellenstruktur fr Tabelle dv_admin_user
--

CREATE TABLE IF NOT EXISTS dv_admin_user (
  UserID int(10) unsigned NOT NULL auto_increment,
  UserState enum('active','inactive','locked') NOT NULL default 'active',
  Username varchar(30) NOT NULL default '',
  Password varchar(32) NOT NULL default '',
  UserCreateAt datetime NOT NULL default '0000-00-00 00:00:00',
  UserLastLogin datetime NOT NULL default '0000-00-00 00:00:00',
  UserLastLogout datetime NOT NULL default '0000-00-00 00:00:00',
  SirName varchar(30) NOT NULL default '',
  LastName varchar(30) NOT NULL default '',
  ChgUser int(5) NOT NULL default '0',
  ChgDatetime datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (UserID)
);

--
-- Daten fr Tabelle dv_admin_user
--

INSERT INTO dv_admin_user (UserID, UserState, Username, Password, UserCreateAt, UserLastLogin, UserLastLogout, SirName, LastName, ChgUser, ChgDatetime) VALUES(1, 'active', 'Master', 'eb0a191797624dd3a48fa681d3061212', '2013-11-25 00:00:00', '2013-11-25 00:00:00', '2013-11-25 00:00:00', '', '', 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_user (UserID, UserState, Username, Password, UserCreateAt, UserLastLogin, UserLastLogout, SirName, LastName, ChgUser, ChgDatetime) VALUES(2, 'active', 'Admin', '21232f297a57a5a743894a0e4a801fc3', '2013-11-25 00:00:00', '2013-11-25 00:00:00', '2013-11-25 00:00:00', '', '', 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_user (UserID, UserState, Username, Password, UserCreateAt, UserLastLogin, UserLastLogout, SirName, LastName, ChgUser, ChgDatetime) VALUES(3, 'active', 'Demo', 'fe01ce2a7fbac8fafaed7c982a04e229', '2013-11-25 00:00:00', '2013-11-25 00:00:00', '2013-11-25 00:00:00', '', '', 1, '2013-11-25 00:00:00');

--
-- Tabellenstruktur fr Tabelle dv_admin_user_rights
--

CREATE TABLE IF NOT EXISTS dv_admin_user_rights (
  UserID int(11) NOT NULL default '0',
  UserRightsID int(11) NOT NULL default '0'
);

--
-- Daten fr Tabelle dv_admin_user_rights
--

INSERT INTO dv_admin_user_rights (UserID, UserRightsID) VALUES(1, 1);
INSERT INTO dv_admin_user_rights (UserID, UserRightsID) VALUES(2, 2);
INSERT INTO dv_admin_user_rights (UserID, UserRightsID) VALUES(3, 3);

--
-- Tabellenstruktur fr Tabelle dv_admin_user_rights_names
--

CREATE TABLE IF NOT EXISTS dv_admin_user_rights_names (
  UserRightsID smallint(3) NOT NULL auto_increment,
  UserRightsState enum('active','inactive','locked') NOT NULL default 'active',
  UserRightsParentID int(5) NOT NULL default '0',
  UserRightsName varchar(20) NOT NULL default '',
  UserRightsDescription text NOT NULL,
  UserRightsSites int(5) NOT NULL default '0',
  ChgUser int(5) NOT NULL default '0',
  ChgDatetime datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (UserRightsID)
);

--
-- Daten fr Tabelle dv_admin_user_rights_names
--

INSERT INTO dv_admin_user_rights_names (UserRightsID, UserRightsState, UserRightsParentID, UserRightsName, UserRightsDescription, UserRightsSites, ChgUser, ChgDatetime) VALUES(1, 'active', 0, 'Master', 'Master Rights', 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_user_rights_names (UserRightsID, UserRightsState, UserRightsParentID, UserRightsName, UserRightsDescription, UserRightsSites, ChgUser, ChgDatetime) VALUES(2, 'active', 1, 'Admin', 'Administrator Rights', 0, 1, '2013-11-25 00:00:00');
INSERT INTO dv_admin_user_rights_names (UserRightsID, UserRightsState, UserRightsParentID, UserRightsName, UserRightsDescription, UserRightsSites, ChgUser, ChgDatetime) VALUES(3, 'active', 2, 'Demo', 'Demo Rights', 0, 1, '2013-11-25 00:00:00');

--
-- Tabellenstruktur fr Tabelle dv_admin_user_rights_page
--

CREATE TABLE IF NOT EXISTS dv_admin_user_rights_page (
  UserRightsID int(5) NOT NULL auto_increment,
  UserGroupID int(5) NOT NULL default '0',
  AdminPageID int(5) NOT NULL default '0',
  PRIMARY KEY  (UserRightsID)
);

--
-- Daten fr Tabelle dv_admin_user_rights_page
--

INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1, 1, 1);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(2, 1, 2);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(3, 1, 3);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(4, 1, 4);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(5, 1, 5);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(9, 1, 9);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(10, 1, 10);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(28, 1, 28);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(29, 1, 29);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(30, 1, 30);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(31, 1, 31);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(32, 1, 32);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(33, 1, 33);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(35, 1, 35);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(36, 1, 36);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(37, 1, 37);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(39, 1, 39);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(265, 1, 40);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(446, 1, 50);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(447, 1, 51);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(563, 1, 54);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(564, 1, 55);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(733, 1, 60);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(734, 1, 61);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(762, 1, 0);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(763, 1, 0);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(765, 1, 63);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(773, 1, 64);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(961, 1, 65);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(962, 1, 66);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(984, 1, 67);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1162, 2, 69);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1161, 2, 68);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1160, 2, 64);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1159, 2, 33);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1158, 2, 31);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1157, 2, 32);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1156, 2, 30);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1155, 2, 29);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1154, 2, 28);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1153, 2, 35);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1151, 2, 63);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1150, 2, 61);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1149, 2, 60);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1148, 2, 51);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1147, 2, 50);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1146, 2, 66);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1145, 2, 65);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1144, 2, 10);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1143, 2, 9);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1142, 2, 67);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1197, 3, 69);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1196, 3, 68);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1195, 3, 35);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1194, 3, 63);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1193, 3, 61);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1192, 3, 60);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1191, 3, 51);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1190, 3, 50);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1189, 3, 66);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1188, 3, 65);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1187, 3, 10);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1186, 3, 9);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1185, 3, 67);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1184, 3, 5);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1183, 3, 4);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1050, 1, 68);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1051, 1, 69);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1141, 2, 5);
INSERT INTO dv_admin_user_rights_page (UserRightsID, UserGroupID, AdminPageID) VALUES(1140, 2, 4);

--
-- Tabellenstruktur fr Tabelle dv_display
--

CREATE TABLE IF NOT EXISTS dv_display (
  DisplayID int(10) unsigned NOT NULL auto_increment,
  DisplayState enum('active','inactive','locked') NOT NULL default 'active',
  DisplaySortNo int(10) unsigned NOT NULL default '0',
  DisplayName varchar(255) NOT NULL,
  DisplayFolder varchar(50) NOT NULL,
  DisplayTemplate varchar(50) NOT NULL,
  ChgUser int(10) unsigned NOT NULL default '0',
  ChgDatetime datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (DisplayID)
);

--
-- Daten fr Tabelle dv_display
--

INSERT INTO dv_display (DisplayID, DisplayState, DisplaySortNo, DisplayName, DisplayFolder, DisplayTemplate, ChgUser, ChgDatetime) VALUES(1, 'active', 1, 'Display1', '01', 'index10.php', 1, '2013-11-25 00:00:00');
INSERT INTO dv_display (DisplayID, DisplayState, DisplaySortNo, DisplayName, DisplayFolder, DisplayTemplate, ChgUser, ChgDatetime) VALUES(2, 'active', 2, 'D&uuml;splay2', '02', 'index04.php', 1, '2013-11-25 00:00:00');
INSERT INTO dv_display (DisplayID, DisplayState, DisplaySortNo, DisplayName, DisplayFolder, DisplayTemplate, ChgUser, ChgDatetime) VALUES(3, 'active', 3, 'Display3', '03', 'index01.php', 1, '2013-11-25 00:00:00');

-- --------------------------------------------------------

--
-- Tabellenstruktur fr Tabelle dv_ini
--

CREATE TABLE IF NOT EXISTS dv_ini (
  INIID int(5) unsigned NOT NULL auto_increment,
  ININame varchar(50) NOT NULL default '',
  INIValue varchar(120) NOT NULL,
  INIHeadline varchar(80) NOT NULL default '',
  INIDescription varchar(255) NOT NULL default '',
  PRIMARY KEY  (INIID)
);

--
-- Daten fr Tabelle dv_ini
--

INSERT INTO dv_ini (INIID, ININame, INIValue, INIHeadline, INIDescription) VALUES(1, 'reload_interval_all', '6', 'Aktualisierungsrate Alles', 'Aktualisierungsrate fr die Anzeige "Alles" in Sekunden');
INSERT INTO dv_ini (INIID, ININame, INIValue, INIHeadline, INIDescription) VALUES(2, 'reload_interval_news', '8', 'Aktualisierungsrate News', 'Aktualisierungsrate fr die Anzeige "News" in Sekunden');
INSERT INTO dv_ini (INIID, ININame, INIValue, INIHeadline, INIDescription) VALUES(3, 'reload_interval_page', '5', 'Aktualisierungsrate Seiten', 'Aktualisierungsrate fr die Anzeige "Seiten" in Sekunden');
INSERT INTO dv_ini (INIID, ININame, INIValue, INIHeadline, INIDescription) VALUES(4, 'reload_interval_substitution', '6', 'Aktualisierungsrate Vertretungsplan', 'Aktualisierungsrate fr die Anzeige "Vertretungsplan" in Sekunden');
INSERT INTO dv_ini (INIID, ININame, INIValue, INIHeadline, INIDescription) VALUES(5, 'reload_interval_scrolltext', '20', 'Aktualisierungsrate Scrolltext', 'Aktualisierungsrate fr die Anzeige "Scrolltext" in Sekunden');
INSERT INTO dv_ini (INIID, ININame, INIValue, INIHeadline, INIDescription) VALUES(6, 'reload_interval_clock', '50', 'Aktualisierungsrate Uhr', 'Aktualisierungsrate fr die Anzeige "Uhr" in Sekunden');

--
-- Tabellenstruktur fr Tabelle dv_media
--

CREATE TABLE IF NOT EXISTS dv_media (
  MediaID int(10) unsigned NOT NULL auto_increment,
  MediaFolderID int(10) unsigned NOT NULL default '0',
  MediaUploadUserID int(10) unsigned NOT NULL default '0',
  MediaUploadDatetime datetime NOT NULL default '0000-00-00 00:00:00',
  MediaFileType varchar(5) NOT NULL default '',
  MediaName varchar(50) NOT NULL default '',
  MediaDescription varchar(255) NOT NULL default '',
  MediaKeywords varchar(255) NOT NULL default '',
  MediagroupID int(2) unsigned default NULL,
  ChgUser int(5) NOT NULL default '0',
  ChgDatetime datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (MediaID),
  KEY MediaFileType (MediaFileType),
  KEY MediaKeywords (MediaKeywords),
  KEY MediaGroupID (MediagroupID)
);

--
-- Daten fr Tabelle dv_media
--

INSERT INTO dv_media (MediaID, MediaFolderID, MediaUploadUserID, MediaUploadDatetime, MediaFileType, MediaName, MediaDescription, MediaKeywords, MediagroupID, ChgUser, ChgDatetime) VALUES(1, 0, 1, '2013-09-25 00:46:46', 'gif', 'firefoxlogo.gif', '', '', 2, 1, '2013-11-25 00:00:00');
INSERT INTO dv_media (MediaID, MediaFolderID, MediaUploadUserID, MediaUploadDatetime, MediaFileType, MediaName, MediaDescription, MediaKeywords, MediagroupID, ChgUser, ChgDatetime) VALUES(2, 0, 1, '2013-09-25 01:27:52', 'gif', 'ec1.gif', '', '', 2, 1, '2013-11-25 00:00:00');
INSERT INTO dv_media (MediaID, MediaFolderID, MediaUploadUserID, MediaUploadDatetime, MediaFileType, MediaName, MediaDescription, MediaKeywords, MediagroupID, ChgUser, ChgDatetime) VALUES(3, 0, 1, '2013-11-10 03:26:28', 'jpg', 'WITTRI16.jpg', '', '', 2, 1, '2013-11-25 00:00:00');
INSERT INTO dv_media (MediaID, MediaFolderID, MediaUploadUserID, MediaUploadDatetime, MediaFileType, MediaName, MediaDescription, MediaKeywords, MediagroupID, ChgUser, ChgDatetime) VALUES(4, 0, 1, '2013-11-13 00:28:52', 'jpg', 'hand-point-right-1.jpg', 'test&uuml;asd', '', 2, 1, '2013-11-25 00:00:00');
INSERT INTO dv_media (MediaID, MediaFolderID, MediaUploadUserID, MediaUploadDatetime, MediaFileType, MediaName, MediaDescription, MediaKeywords, MediagroupID, ChgUser, ChgDatetime) VALUES(5, 0, 1, '2013-11-13 01:07:26', 'jpg', 'hand-point-left-2.jpg', '', '', 2, 1, '2013-11-25 00:00:00');
INSERT INTO dv_media (MediaID, MediaFolderID, MediaUploadUserID, MediaUploadDatetime, MediaFileType, MediaName, MediaDescription, MediaKeywords, MediagroupID, ChgUser, ChgDatetime) VALUES(6, 0, 1, '2013-11-22 01:42:17', 'JPG', 'DSC00032.JPG', '', '', 2, 1, '2013-11-25 00:00:00');

--
-- Tabellenstruktur fr Tabelle dv_media_allocation
--

CREATE TABLE IF NOT EXISTS dv_media_allocation (
  AllocationMediaID int(11) NOT NULL default '0',
  AllocationPageID int(10) NOT NULL default '0',
  AllocationContentID int(11) NOT NULL default '0',
  AllocationType varchar(30) NOT NULL default '',
  PRIMARY KEY  (AllocationMediaID,AllocationPageID,AllocationContentID)
);

--
-- Daten fr Tabelle dv_media_allocation
--

INSERT INTO dv_media_allocation (AllocationMediaID, AllocationPageID, AllocationContentID, AllocationType) VALUES(3, 10, 1, 'fcDeleteAll');
INSERT INTO dv_media_allocation (AllocationMediaID, AllocationPageID, AllocationContentID, AllocationType) VALUES(3, 51, 2, 'fcDeleteAll');
INSERT INTO dv_media_allocation (AllocationMediaID, AllocationPageID, AllocationContentID, AllocationType) VALUES(5, 51, 1, 'fcDeleteAll');
INSERT INTO dv_media_allocation (AllocationMediaID, AllocationPageID, AllocationContentID, AllocationType) VALUES(6, 10, 3, 'fcDeleteAll');

--
-- Tabellenstruktur fr Tabelle dv_media_folder
--

CREATE TABLE IF NOT EXISTS dv_media_folder (
  MediaFolderID int(9) unsigned NOT NULL auto_increment,
  MediaFolderName varchar(255) NOT NULL default '',
  MediaFolderDescription varchar(255) NOT NULL default '',
  ChgUser int(5) NOT NULL default '0',
  ChgDatetime datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (MediaFolderID)
);

--
-- Tabellenstruktur fr Tabelle dv_media_group
--

CREATE TABLE IF NOT EXISTS dv_media_group (
  MediagroupID int(9) unsigned NOT NULL auto_increment,
  MediagroupName varchar(255) NOT NULL default '',
  MediagroupFiletypes varchar(255) NOT NULL default '',
  MediagroupPos int(9) unsigned NOT NULL default '0',
  ChgUser int(5) NOT NULL default '0',
  ChgDatetime datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (MediagroupID)
);

--
-- Daten fr Tabelle dv_media_group
--

INSERT INTO dv_media_group (MediagroupID, MediagroupName, MediagroupFiletypes, MediagroupPos, ChgUser, ChgDatetime) VALUES(1, 'Sonstige', '', 1, 1, '0000-00-00 00:00:00');
INSERT INTO dv_media_group (MediagroupID, MediagroupName, MediagroupFiletypes, MediagroupPos, ChgUser, ChgDatetime) VALUES(2, 'Bilder', 'jpg|jpeg|gif|bmp|png|', 2, 1, '0000-00-00 00:00:00');
INSERT INTO dv_media_group (MediagroupID, MediagroupName, MediagroupFiletypes, MediagroupPos, ChgUser, ChgDatetime) VALUES(3, 'Musik', 'mp3|wav|', 3, 1, '0000-00-00 00:00:00');
INSERT INTO dv_media_group (MediagroupID, MediagroupName, MediagroupFiletypes, MediagroupPos, ChgUser, ChgDatetime) VALUES(4, 'Video', 'flv|avi|mov|mpg|', 4, 1, '0000-00-00 00:00:00');
INSERT INTO dv_media_group (MediagroupID, MediagroupName, MediagroupFiletypes, MediagroupPos, ChgUser, ChgDatetime) VALUES(5, 'PDF', 'pdf|', 5, 1, '0000-00-00 00:00:00');
INSERT INTO dv_media_group (MediagroupID, MediagroupName, MediagroupFiletypes, MediagroupPos, ChgUser, ChgDatetime) VALUES(6, 'Word', 'doc|', 6, 1, '0000-00-00 00:00:00');

--
-- Tabellenstruktur fr Tabelle dv_news
--

CREATE TABLE IF NOT EXISTS dv_news (
  NewsID int(10) unsigned NOT NULL auto_increment,
  NewsState enum('active','inactive','locked') NOT NULL default 'inactive',
  NewsSortNo int(10) unsigned NOT NULL,
  NewsDate date NOT NULL default '0000-00-00',
  NewsValidTo datetime NOT NULL default '0000-00-00 00:00:00',
  NewsHl varchar(255) NOT NULL default '',
  NewsTeaser varchar(255) NOT NULL default '',
  NewsText text NOT NULL,
  NewsMediaID int(10) NOT NULL default '0',
  NewsHighlight tinyint(1) NOT NULL default '0',
  NewsViewCount int(10) unsigned NOT NULL default '0',
  NewsDisplayID int(10) unsigned NOT NULL default '1',
  ChgUser int(10) NOT NULL default '0',
  ChgDatetime datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (NewsID)
);

--
-- Daten fr Tabelle dv_news
--

INSERT INTO dv_news (NewsID, NewsState, NewsSortNo, NewsDate, NewsValidTo, NewsHl, NewsTeaser, NewsText, NewsMediaID, NewsHighlight, NewsViewCount, NewsDisplayID, ChgUser, ChgDatetime) VALUES(1, 'active', 1, '2013-11-01', '2020-01-01 00:00:00', 'Display2 Aktuelles1', 'Display2 Aktuelles1', '<p><span>Beispieltext</span><br /><span><em><strong><span style="text-decoration: underline;">Beispieltext</span></strong></em><br /><br /></span><span><br /></span><span><img title="firefoxlogo.gif" src="media/3.jpg" alt="firefoxlogo.gif" width="370" height="278" /></span><br /><span><br /></span></p>', 0, 0, 0, 2, 1, '2013-11-25 00:00:00');
INSERT INTO dv_news (NewsID, NewsState, NewsSortNo, NewsDate, NewsValidTo, NewsHl, NewsTeaser, NewsText, NewsMediaID, NewsHighlight, NewsViewCount, NewsDisplayID, ChgUser, ChgDatetime) VALUES(2, 'active', 2, '2013-11-01', '2020-01-01 00:00:00', 'Display2 Aktuelles2 Display2 Aktuelles2 ', '', '<div align="left"><em><span style="text-decoration: underline;"><span style="font-family: courier new,courier,monospace;"><strong>Aktuelles1</strong></span></span></em></div>\r\n<div align="left">&nbsp;</div>\r\n<ol>\r\n<li><span style="font-family: courier new,courier,monospace;"><strong>Text</strong></span></li>\r\n<li><span style="font-family: courier new,courier,monospace;"><strong>Text</strong></span></li>\r\n<li><span style="font-family: courier new,courier,monospace;"><strong>Text</strong></span></li>\r\n</ol>\r\n<div align="left">&nbsp;</div>', 0, 1, 0, 2, 1, '2013-11-25 00:00:00');
INSERT INTO dv_news (NewsID, NewsState, NewsSortNo, NewsDate, NewsValidTo, NewsHl, NewsTeaser, NewsText, NewsMediaID, NewsHighlight, NewsViewCount, NewsDisplayID, ChgUser, ChgDatetime) VALUES(3, 'active', 4, '2013-11-01', '2020-01-01 00:00:00', 'Display1 Aktuelles2', 'Display1 Aktuelles2', '<p>Display1<br />Aktuelles2</p>\r\n<p>&nbsp;</p>\r\n<p><img src="media/6.JPG" alt="" width="370" height="278" /></p>', 0, 0, 0, 1, 1, '2013-11-25 00:00:00');
INSERT INTO dv_news (NewsID, NewsState, NewsSortNo, NewsDate, NewsValidTo, NewsHl, NewsTeaser, NewsText, NewsMediaID, NewsHighlight, NewsViewCount, NewsDisplayID, ChgUser, ChgDatetime) VALUES(4, 'active', 3, '2013-11-01', '2020-01-01 00:00:00', 'Display1 Aktuelles1', 'Display1 Aktuelles1', '<p>Display1 Aktuelles1</p>', 0, 1, 0, 1, 1, '2013-11-25 00:00:00');

--
-- Tabellenstruktur fr Tabelle dv_page
--

CREATE TABLE IF NOT EXISTS dv_page (
  PageID int(10) unsigned NOT NULL auto_increment,
  PageState enum('active','inactive','locked') NOT NULL default 'active',
  PageSortNo int(10) unsigned NOT NULL default '0',
  PageName varchar(50) NOT NULL default '',
  PageTitle varchar(50) NOT NULL default '',
  PageDescription varchar(255) NOT NULL default '',
  PageKeywords varchar(255) NOT NULL default '',
  PageHeadlineImage varchar(50) NOT NULL default '',
  PageTypeID int(5) unsigned NOT NULL default '0',
  PageTemplate varchar(50) NOT NULL default '',
  PageContentID int(10) unsigned NOT NULL default '0',
  PageBackgroundMediaID int(5) unsigned NOT NULL default '0',
  PageStartMediaID int(5) unsigned NOT NULL default '0',
  PageDisplayID int(10) unsigned NOT NULL default '1',
  ChgUser int(5) NOT NULL default '0',
  ChgDatetime datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (PageID),
  KEY PageSortNo (PageSortNo),
  KEY PageState (PageState)
);

--
-- Daten fr Tabelle dv_page
--

INSERT INTO dv_page (PageID, PageState, PageSortNo, PageName, PageTitle, PageDescription, PageKeywords, PageHeadlineImage, PageTypeID, PageTemplate, PageContentID, PageBackgroundMediaID, PageStartMediaID, PageDisplayID, ChgUser, ChgDatetime) VALUES(1, 'active', 1, 'Seite1', '', '', '', '', 2, '', 1, 0, 0, 1, 1, '2013-11-25 00:00:00');
INSERT INTO dv_page (PageID, PageState, PageSortNo, PageName, PageTitle, PageDescription, PageKeywords, PageHeadlineImage, PageTypeID, PageTemplate, PageContentID, PageBackgroundMediaID, PageStartMediaID, PageDisplayID, ChgUser, ChgDatetime) VALUES(2, 'active', 3, 'Seite3', '', '', '', '', 2, '', 2, 0, 0, 2, 1, '2013-11-25 00:00:00');
INSERT INTO dv_page (PageID, PageState, PageSortNo, PageName, PageTitle, PageDescription, PageKeywords, PageHeadlineImage, PageTypeID, PageTemplate, PageContentID, PageBackgroundMediaID, PageStartMediaID, PageDisplayID, ChgUser, ChgDatetime) VALUES(3, 'active', 2, 'Seite2', '', '', '', '', 2, '', 3, 0, 0, 2, 1, '2013-11-25 00:00:00');
INSERT INTO dv_page (PageID, PageState, PageSortNo, PageName, PageTitle, PageDescription, PageKeywords, PageHeadlineImage, PageTypeID, PageTemplate, PageContentID, PageBackgroundMediaID, PageStartMediaID, PageDisplayID, ChgUser, ChgDatetime) VALUES(4, 'active', 4, 'Seite4', '', '', '', '', 2, '', 4, 0, 0, 1, 1, '2013-11-25 00:00:00');

--
-- Tabellenstruktur fr Tabelle dv_page_content
--

CREATE TABLE IF NOT EXISTS dv_page_content (
  PageContentID int(10) unsigned NOT NULL auto_increment,
  PageContent text NOT NULL,
  PRIMARY KEY  (PageContentID)
);

--
-- Daten fr Tabelle dv_page_content
--

INSERT INTO dv_page_content (PageContentID, PageContent) VALUES(1, '<p style="text-align: center;"><img style="float: right; margin-left: 40px; margin-right: 40px;" src="media/5.jpg" alt="" width="62" height="62" /><span style="font-size: medium; color: #ff6600;"><strong>Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat.</strong></span></p>\r\n<p>&nbsp;</p>\r\n<p>&nbsp;</p>\r\n<p>&nbsp;</p>');
INSERT INTO dv_page_content (PageContentID, PageContent) VALUES(2, '<h1>Seite3</h1>\r\n<p>&nbsp;</p>\r\n<p><img style="float: right; margin-left: 30px; margin-bottom: 30px;" src="media/3.jpg" alt="" width="600" height="450" /> Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi.</p>\r\n<p>&nbsp;</p>\r\n<p><strong>Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi.</strong></p>\r\n<p>&nbsp;</p>\r\n<p><span style="font-family: comic sans ms,sans-serif;"><em>Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi.</em></span></p>\r\n<p>&nbsp;</p>\r\n<p>&nbsp;</p>');
INSERT INTO dv_page_content (PageContentID, PageContent) VALUES(3, '<p><span style="font-size: large; color: #800000;">Seite2</span></p>\r\n<p>&nbsp;</p>\r\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi.</p>\r\n<p>&nbsp;</p>\r\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi.</p>\r\n<p>&nbsp;</p>\r\n<p>Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy nibh euismod tincidunt ut laoreet dolore magna aliquam erat volutpat. Ut wisi enim ad minim veniam, quis nostrud exerci tation ullamcorper suscipit lobortis nisl ut aliquip ex ea commodo consequat. Duis autem vel eum iriure dolor in hendrerit in vulputate velit esse molestie consequat, vel illum dolore eu feugiat nulla facilisis at vero eros et accumsan et iusto odio dignissim qui blandit praesent luptatum zzril delenit augue duis dolore te feugait nulla facilisi.</p>');
INSERT INTO dv_page_content (PageContentID, PageContent) VALUES(4, '<h1 style="text-align: center;">Lorem ipsum dolor sit amet, consectetuer adipiscing elit, sed diam nonummy</h1>');

--
-- Tabellenstruktur fr Tabelle dv_scrolltext
--

CREATE TABLE IF NOT EXISTS dv_scrolltext (
  ScrolltextID int(10) unsigned NOT NULL auto_increment,
  ScrolltextState enum('active','inactive','locked') NOT NULL default 'active',
  ScrolltextSortNo int(10) unsigned NOT NULL,
  ScrolltextValue text NOT NULL,
  ScrolltextDirection varchar(20) NOT NULL,
  ScrolltextAmount varchar(20) NOT NULL,
  ScrolltextDelay varchar(20) NOT NULL,
  ScrolltextBehaviour varchar(20) NOT NULL,
  ScrolltextAlign varchar(20) NOT NULL,
  ScrolltextHspace int(5) NOT NULL,
  ScrolltextDisplayID int(10) unsigned NOT NULL default '1',
  ChgUser int(5) NOT NULL default '0',
  ChgDatetime datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (ScrolltextID),
  KEY ScrolltextState (ScrolltextState),
  KEY ScrolltextSortNo (ScrolltextSortNo)
);

--
-- Daten fr Tabelle dv_scrolltext
--

INSERT INTO dv_scrolltext (ScrolltextID, ScrolltextState, ScrolltextSortNo, ScrolltextValue, ScrolltextDirection, ScrolltextAmount, ScrolltextDelay, ScrolltextBehaviour, ScrolltextAlign, ScrolltextHspace, ScrolltextDisplayID, ChgUser, ChgDatetime) VALUES(1, 'active', 2, ' *** Lauftext Display1 *** Lauftext Display1 *** Lauftext Display1 *** Lauftext Display1 *** ', '', '', '', '', '', 0, 1, 1, '2013-11-25 00:00:00');
INSERT INTO dv_scrolltext (ScrolltextID, ScrolltextState, ScrolltextSortNo, ScrolltextValue, ScrolltextDirection, ScrolltextAmount, ScrolltextDelay, ScrolltextBehaviour, ScrolltextAlign, ScrolltextHspace, ScrolltextDisplayID, ChgUser, ChgDatetime) VALUES(2, 'active', 1, 'Lauftext Display1 Test', '', '', '', '', '', 0, 1, 1, '2013-11-25 00:00:00');

--
-- Tabellenstruktur fr Tabelle dv_substitution
--

CREATE TABLE IF NOT EXISTS dv_substitution (
  SubstitutionID int(9) unsigned NOT NULL auto_increment,
  SubstitutionState enum('active','inactive','locked') NOT NULL default 'active',
  SubstitutionSortNo int(3) NOT NULL,
  SubstitutionImportMasterID int(10) unsigned NOT NULL default '0',
  SubstitutionImportOption tinyint(1) unsigned NOT NULL default '0',
  SubstitutionImportOptionType int(10) unsigned NOT NULL default '0',
  SubstitutionImportURL varchar(255) NOT NULL,
  SubstitutionImportDayURL varchar(255) NOT NULL,
  SubstitutionImportDayCount int(10) NOT NULL default '0',
  SubstitutionImportFile varchar(255) NOT NULL,
  SubstitutionImportFileSize varchar(20) NOT NULL,
  SubstitutionImportFileDatetime varchar(50) NOT NULL,
  SubstitutionImportDatetime datetime NOT NULL default '0000-00-00 00:00:00',
  SubstitutionImportDayTime time NOT NULL default '00:00:00',
  SubstitutionDate date NOT NULL default '0000-00-00',
  SubstitutionHl varchar(255) NOT NULL,
  SubstitutionInfo text NOT NULL,
  SubstitutionInfo2 text NOT NULL,
  SubstitutionText text NOT NULL,
  SubstitutionMaxRow int(3) NOT NULL default '0',
  SubstitutionCols int(2) NOT NULL default '0',
  SubstitutionRows int(3) NOT NULL default '0',
  SubstitutionColHeadlines text NOT NULL,
  SubstitutionDisplayID int(10) unsigned NOT NULL default '1',
  ChgUser int(5) NOT NULL default '0',
  ChgDatetime datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (SubstitutionID),
  KEY SubstitutionImportOption (SubstitutionImportOption),
  KEY SubstitutionState (SubstitutionState),
  KEY SubstitutionSortNo (SubstitutionSortNo)
);

--
-- Daten fr Tabelle dv_substitution
--

INSERT INTO dv_substitution (SubstitutionID, SubstitutionState, SubstitutionSortNo, SubstitutionImportMasterID, SubstitutionImportOption, SubstitutionImportOptionType, SubstitutionImportURL, SubstitutionImportDayURL, SubstitutionImportDayCount, SubstitutionImportFile, SubstitutionImportFileSize, SubstitutionImportFileDatetime, SubstitutionImportDatetime, SubstitutionImportDayTime, SubstitutionDate, SubstitutionHl, SubstitutionInfo, SubstitutionInfo2, SubstitutionText, SubstitutionMaxRow, SubstitutionCols, SubstitutionRows, SubstitutionColHeadlines, SubstitutionDisplayID, ChgUser, ChgDatetime) VALUES(3, 'active', 1, 0, 1, 1, 'D:\\www\\dview\\_prod\\vpm_testplan_vom_12-11-2013.xml', '', 0, 'vpm_testplan_vom_12-11-2013.xml', '5875', '2013-11-25 18:53:29', '2013-11-25 00:00:00', '00:00:00', '2013-11-12', 'Vertretungsplan f&uuml;r Mittwoch, 26.11.2013', 'Mitteilung: ''Hallo'' Sch&uuml;ler', '&quot;Hallo&quot; Lehrer<br>Willkommen', '', 10, 8, 18, 'Vertretung|Std|Klasse|Fach|statt|Lehrer|Raum|Sonstiges|', 1, 1, '2013-11-25 00:00:00');

--
-- Tabellenstruktur fr Tabelle dv_substitution_absence_rows
--

CREATE TABLE IF NOT EXISTS dv_substitution_absence_rows (
  SubstitutionID int(5) NOT NULL,
  SubstitutionAbsenceRowID int(5) unsigned NOT NULL,
  SubstitutionAbsenceRow text NOT NULL,
  KEY SubstitutionID (SubstitutionID),
  KEY SubstitutionAbsenceRowID (SubstitutionAbsenceRowID)
);

--
-- Daten fr Tabelle dv_substitution_absence_rows
--

INSERT INTO dv_substitution_absence_rows (SubstitutionID, SubstitutionAbsenceRowID, SubstitutionAbsenceRow) VALUES(3, 4, 'Name=Person 4|Betrifft=1 - 10|Sichtbar=Ja');
INSERT INTO dv_substitution_absence_rows (SubstitutionID, SubstitutionAbsenceRowID, SubstitutionAbsenceRow) VALUES(3, 3, 'Name=Person 3|Betrifft=5 - 7|Sichtbar=Ja');
INSERT INTO dv_substitution_absence_rows (SubstitutionID, SubstitutionAbsenceRowID, SubstitutionAbsenceRow) VALUES(3, 2, 'Name=Person 2|Betrifft=4|Sichtbar=Ja');
INSERT INTO dv_substitution_absence_rows (SubstitutionID, SubstitutionAbsenceRowID, SubstitutionAbsenceRow) VALUES(3, 1, 'Name=Person 1|Betrifft=1 - 3|Sichtbar=Ja');

--
-- Tabellenstruktur fr Tabelle dv_substitution_pduty_rows
--

CREATE TABLE IF NOT EXISTS dv_substitution_pduty_rows (
  SubstitutionID int(5) NOT NULL,
  SubstitutionPlaygroundDutyRowID int(5) unsigned NOT NULL,
  SubstitutionPlaygroundDutyRow text NOT NULL,
  KEY SubstitutionID (SubstitutionID),
  KEY SubstitutionPlaygroundDutyRowID (SubstitutionPlaygroundDutyRowID)
);

--
-- Daten fr Tabelle dv_substitution_pduty_rows
--

INSERT INTO dv_substitution_pduty_rows (SubstitutionID, SubstitutionPlaygroundDutyRowID, SubstitutionPlaygroundDutyRow) VALUES(3, 3, 'Aufsicht=Person 3|Zeit=3. Pause|Ort=c3|Sichtbar=Nein');
INSERT INTO dv_substitution_pduty_rows (SubstitutionID, SubstitutionPlaygroundDutyRowID, SubstitutionPlaygroundDutyRow) VALUES(3, 2, 'Aufsicht=Person 2|Zeit=2. Pause|Ort=b2|Sichtbar=Nein');
INSERT INTO dv_substitution_pduty_rows (SubstitutionID, SubstitutionPlaygroundDutyRowID, SubstitutionPlaygroundDutyRow) VALUES(3, 1, 'Aufsicht=Person 1|Zeit=1. Pause|Ort=a1|Sichtbar=Ja');

--
-- Tabellenstruktur fr Tabelle dv_substitution_rows
--

CREATE TABLE IF NOT EXISTS dv_substitution_rows (
  SubstitutionID int(5) NOT NULL,
  SubstitutionRowID int(5) unsigned NOT NULL,
  SubstitutionRow text NOT NULL,
  KEY SubstitutionID (SubstitutionID),
  KEY SubstitutionRowID (SubstitutionRowID)
);

--
-- Daten fr Tabelle dv_substitution_rows
--

INSERT INTO dv_substitution_rows (SubstitutionID, SubstitutionRowID, SubstitutionRow) VALUES(3, 18, 'Person 6|6|6f|Fg||Person F|Raum 6||');
INSERT INTO dv_substitution_rows (SubstitutionID, SubstitutionRowID, SubstitutionRow) VALUES(3, 17, 'Person 5|5|5e|Ef||Person E|Raum 5||');
INSERT INTO dv_substitution_rows (SubstitutionID, SubstitutionRowID, SubstitutionRow) VALUES(3, 16, 'Person 4|4|4d|De||Person D|Raum 4||');
INSERT INTO dv_substitution_rows (SubstitutionID, SubstitutionRowID, SubstitutionRow) VALUES(3, 15, 'Person 3|3|3c|Cd||Person C|Raum 3||');
INSERT INTO dv_substitution_rows (SubstitutionID, SubstitutionRowID, SubstitutionRow) VALUES(3, 14, 'Person 2|2|2b|Bc||Person B|Raum 2|Beispieltext|');
INSERT INTO dv_substitution_rows (SubstitutionID, SubstitutionRowID, SubstitutionRow) VALUES(3, 13, 'Person 1|1|1a|Ab||Person A|Raum 1||');
INSERT INTO dv_substitution_rows (SubstitutionID, SubstitutionRowID, SubstitutionRow) VALUES(3, 12, 'Person 6|6|6f|Fg||Person F|Raum 6||');
INSERT INTO dv_substitution_rows (SubstitutionID, SubstitutionRowID, SubstitutionRow) VALUES(3, 11, 'Person 5|5|5e|Ef||Person E|Raum 5||');
INSERT INTO dv_substitution_rows (SubstitutionID, SubstitutionRowID, SubstitutionRow) VALUES(3, 10, 'Person 4|4|4d|De||Person D|Raum 4||');
INSERT INTO dv_substitution_rows (SubstitutionID, SubstitutionRowID, SubstitutionRow) VALUES(3, 9, 'Person 3|3|3c|Cd||Person C|Raum 3||');
INSERT INTO dv_substitution_rows (SubstitutionID, SubstitutionRowID, SubstitutionRow) VALUES(3, 8, 'Person 2|2|2b|Bc||Person B|Raum 2|Beispieltext|');
INSERT INTO dv_substitution_rows (SubstitutionID, SubstitutionRowID, SubstitutionRow) VALUES(3, 7, 'Person 1|1|1a|Ab||Person A|Raum 1||');
INSERT INTO dv_substitution_rows (SubstitutionID, SubstitutionRowID, SubstitutionRow) VALUES(3, 6, 'Person 6|6|6f|Fg||Person F|Raum 6||');
INSERT INTO dv_substitution_rows (SubstitutionID, SubstitutionRowID, SubstitutionRow) VALUES(3, 5, 'Person 5|5|5e|Ef||Person E|Raum 5||');
INSERT INTO dv_substitution_rows (SubstitutionID, SubstitutionRowID, SubstitutionRow) VALUES(3, 4, 'Person 4|4|4d|De||Person D|Raum 4||');
INSERT INTO dv_substitution_rows (SubstitutionID, SubstitutionRowID, SubstitutionRow) VALUES(3, 3, 'Person 3|3|3c|Cd||Person C|Raum 3||');
INSERT INTO dv_substitution_rows (SubstitutionID, SubstitutionRowID, SubstitutionRow) VALUES(3, 2, 'Person 2|2|2b|Bc||Person B|Raum 2|Beispieltext|');
INSERT INTO dv_substitution_rows (SubstitutionID, SubstitutionRowID, SubstitutionRow) VALUES(3, 1, 'Person 1|1|1a|Ab||Person A|Raum 1||');
