<?
// ---------------------------------------------------------
// DView 2.1 - 2013-11-01
// www.dview.de
//  2013 Ingmar Ober - www.oberin.de
// Released under the Creative Commons License CC-BY-SA.
// http://creativecommons.org/licenses/by-sa/3.0/deed.de
// ---------------------------------------------------------

// INI MAIN (Haupteinstellungen Frontend, Admin)
// ---------------------------------------------------------


define("WEB_BASE", "http://" . $_SERVER["HTTP_HOST"] . "/dview/");		/* HTTP_ROOT */

define("WEB_PATH_ROOT", "/dview/");										/* FTP-Server-Root/WEB_PATH_ROOT */


// DATABASE
define("MAIN_DB_HOST", "localhost");
define("MAIN_DB_NAME", "dview");
define("MAIN_DB_USER", "root");
define("MAIN_DB_PASSWORD", "");
define("TABLE_PREFIX", "dv_");


// PATH
define("WEB_BASE_PATH", $_SERVER["DOCUMENT_ROOT"]);
define("WEB_PATH_PHP_ROOT", WEB_BASE_PATH . WEB_PATH_ROOT);

define("ADMIN_PATH_ROOT", WEB_PATH_ROOT . "admin/");
define("ADMIN_PATH_PHP_ROOT", WEB_BASE_PATH . ADMIN_PATH_ROOT);

define("WEB_PATH_PHP_CFG",  WEB_PATH_PHP_ROOT . "config/");
define("WEB_PATH_FUNC",  WEB_BASE . "function/");
define("WEB_PATH_PHP_FUNC",  WEB_PATH_PHP_ROOT . "function/");

define("TEMPLATE_PATH", "template/");
define("DISPLAY_PATH", "display/");
define("DISPLAY_PATH_PHP", WEB_PATH_PHP_ROOT . "display/");

define("DISPLAY_CONFIG_PATH", "config/");
define("DISPLAY_FRAMESET_PATH", "frameset/");

define("MEDIA_PATH", WEB_PATH_ROOT . "media/");
define("MEDIA_PATH_PHP", WEB_PATH_PHP_ROOT . "media/");
define("FILE_BROWSER_MEDIA_PATH", "../media/");

define("ADMIN_DEMO_STATE", false);
define("ADMIN_SUBSTITUTION_INFO", true);

define("SUBSTITUTION_ONLYUPCOMING", false);	// Nur Vertretungsplaene >= Heute (Datum im Dateinamen)

// GLOBALS
$GLOBALS = array();
$GLOBALS["Homepage"] = array();
$GLOBALS["Homepage"]["Title"] = "DView";

$GLOBALS["Months"] = array("Dezember", "Januar", "Februar", "Mrz", "April", "Mai", "Juni", "Juli", "August", "September", "Oktober", "November", "Dezember");
$GLOBALS["WeekDays"] = array("Sonntag", "Montag", "Dienstag", "Mittwoch", "Donnerstag", "Freitag", "Samstag", "Sonntag");
$GLOBALS["WKDays"] = array("So", "Mo", "Di", "Mi", "Do", "Fr", "Sa", "So");

// MEDIA
$GLOBALS["GLOBAL_UPLOAD_MAXFILESIZE"] = "8388608"; // 8MB (20971520 20MB)

$GLOBALS["arFileImageAttribute"] = array("gif", "GIF", "jpg", "JPG", "png", "PNG", "wbmp", "WBMP");
$GLOBALS["arFileAudioAttribute"] = array("mp3", "MP3", "ogg", "OGG", "wav", "WAV");
$GLOBALS["arFileVideoAttribute"] = array("avi", "AVI", "mpg", "MPG", "mpeg", "MPEG", "rm", "RM", "mov", "MOV", "flv", "FLV", "xvid", "XVID", "divx", "DIVX");
$GLOBALS["arFilePDFAttribute"] = array("pdf", "PDF");
$GLOBALS["arFileDOCAttribute"] = array("doc", "DOC");
$GLOBALS["arFileSWFAttribute"] = array("swf", "SWF");

// TIMEZONE (>PHP5)
if(function_exists("date_default_timezone_set") && function_exists("date_default_timezone_get")){
	@date_default_timezone_set(@date_default_timezone_get());
}

// USER
if(!isset($_SESSION["UserID"])){
	$_SESSION["UserID"] = 0;
}

// INCLUDES
include (WEB_PATH_PHP_FUNC . "db.php");
include (WEB_PATH_PHP_CFG . "ini.config.php");
?>